using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DisplayingFormsCSharp
{
	/// <summary>
	/// Summary description for AutoSize.
	/// </summary>
	public class AutoSize : System.Windows.Forms.Form
	{
		bool doResize;
		
		internal System.Windows.Forms.Panel Panel3;
		internal System.Windows.Forms.CheckBox cbManual;
		internal System.Windows.Forms.TextBox tbBaseY;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.TextBox tbBaseX;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Button Button1;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.TextBox TextBox3;
		internal System.Windows.Forms.Panel Panel2;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Panel Panel1;
		internal System.Windows.Forms.RadioButton RadioButton3;
		internal System.Windows.Forms.RadioButton RadioButton2;
		internal System.Windows.Forms.RadioButton RadioButton1;
		internal System.Windows.Forms.TextBox TextBox2;
		internal System.Windows.Forms.TextBox TextBox1;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AutoSize()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			SizeF theSize;

			theSize = GetAutoScaleSize(this.Font);
			this.tbBaseX.Text = (theSize.Width).ToString();
			this.tbBaseY.Text = theSize.Height.ToString();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Panel3 = new System.Windows.Forms.Panel();
			this.cbManual = new System.Windows.Forms.CheckBox();
			this.tbBaseY = new System.Windows.Forms.TextBox();
			this.Label7 = new System.Windows.Forms.Label();
			this.tbBaseX = new System.Windows.Forms.TextBox();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label5 = new System.Windows.Forms.Label();
			this.Button1 = new System.Windows.Forms.Button();
			this.Label4 = new System.Windows.Forms.Label();
			this.TextBox3 = new System.Windows.Forms.TextBox();
			this.Panel2 = new System.Windows.Forms.Panel();
			this.Label3 = new System.Windows.Forms.Label();
			this.Panel1 = new System.Windows.Forms.Panel();
			this.RadioButton3 = new System.Windows.Forms.RadioButton();
			this.RadioButton2 = new System.Windows.Forms.RadioButton();
			this.RadioButton1 = new System.Windows.Forms.RadioButton();
			this.TextBox2 = new System.Windows.Forms.TextBox();
			this.TextBox1 = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.Panel3.SuspendLayout();
			this.Panel1.SuspendLayout();
			this.SuspendLayout();
			// 
			// Panel3
			// 
			this.Panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Panel3.Controls.Add(this.cbManual);
			this.Panel3.Controls.Add(this.tbBaseY);
			this.Panel3.Controls.Add(this.Label7);
			this.Panel3.Controls.Add(this.tbBaseX);
			this.Panel3.Controls.Add(this.Label6);
			this.Panel3.Controls.Add(this.Label5);
			this.Panel3.Location = new System.Drawing.Point(368, 16);
			this.Panel3.Name = "Panel3";
			this.Panel3.Size = new System.Drawing.Size(168, 120);
			this.Panel3.TabIndex = 19;
			// 
			// cbManual
			// 
			this.cbManual.Location = new System.Drawing.Point(8, 88);
			this.cbManual.Name = "cbManual";
			this.cbManual.TabIndex = 5;
			this.cbManual.Text = "Manually Scale";
			this.cbManual.CheckedChanged += new System.EventHandler(this.cbManual_CheckedChanged);
			// 
			// tbBaseY
			// 
			this.tbBaseY.Location = new System.Drawing.Point(56, 64);
			this.tbBaseY.Name = "tbBaseY";
			this.tbBaseY.ReadOnly = true;
			this.tbBaseY.TabIndex = 4;
			this.tbBaseY.TabStop = false;
			this.tbBaseY.Text = "";
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Location = new System.Drawing.Point(32, 66);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(15, 16);
			this.Label7.TabIndex = 3;
			this.Label7.Text = "Y:";
			// 
			// tbBaseX
			// 
			this.tbBaseX.Location = new System.Drawing.Point(56, 40);
			this.tbBaseX.Name = "tbBaseX";
			this.tbBaseX.ReadOnly = true;
			this.tbBaseX.TabIndex = 2;
			this.tbBaseX.TabStop = false;
			this.tbBaseX.Text = "";
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Location = new System.Drawing.Point(32, 42);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(15, 16);
			this.Label6.TabIndex = 1;
			this.Label6.Text = "X:";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Location = new System.Drawing.Point(8, 16);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(107, 16);
			this.Label5.TabIndex = 0;
			this.Label5.Text = "AutoScaleBaseSize:";
			// 
			// Button1
			// 
			this.Button1.Location = new System.Drawing.Point(384, 144);
			this.Button1.Name = "Button1";
			this.Button1.Size = new System.Drawing.Size(136, 23);
			this.Button1.TabIndex = 21;
			this.Button1.Text = "Increase by 10%";
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Location = new System.Drawing.Point(408, 8);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(90, 16);
			this.Label4.TabIndex = 20;
			this.Label4.Text = "Form Information";
			// 
			// TextBox3
			// 
			this.TextBox3.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.TextBox3.Location = new System.Drawing.Point(8, 144);
			this.TextBox3.Name = "TextBox3";
			this.TextBox3.ReadOnly = true;
			this.TextBox3.Size = new System.Drawing.Size(336, 20);
			this.TextBox3.TabIndex = 18;
			this.TextBox3.TabStop = false;
			this.TextBox3.Text = "Textbox with AutoSize = True, but Font Set";
			// 
			// Panel2
			// 
			this.Panel2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.Panel2.Location = new System.Drawing.Point(8, 136);
			this.Panel2.Name = "Panel2";
			this.Panel2.Size = new System.Drawing.Size(336, 2);
			this.Panel2.TabIndex = 17;
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(280, 8);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(52, 16);
			this.Label3.TabIndex = 16;
			this.Label3.Text = "Font Size";
			// 
			// Panel1
			// 
			this.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Panel1.Controls.Add(this.RadioButton3);
			this.Panel1.Controls.Add(this.RadioButton2);
			this.Panel1.Controls.Add(this.RadioButton1);
			this.Panel1.Location = new System.Drawing.Point(256, 16);
			this.Panel1.Name = "Panel1";
			this.Panel1.Size = new System.Drawing.Size(88, 104);
			this.Panel1.TabIndex = 15;
			// 
			// RadioButton3
			// 
			this.RadioButton3.Location = new System.Drawing.Point(16, 64);
			this.RadioButton3.Name = "RadioButton3";
			this.RadioButton3.Size = new System.Drawing.Size(56, 24);
			this.RadioButton3.TabIndex = 2;
			this.RadioButton3.Text = "36";
			this.RadioButton3.CheckedChanged += new System.EventHandler(this.RadioButton3_CheckedChanged);
			// 
			// RadioButton2
			// 
			this.RadioButton2.Location = new System.Drawing.Point(16, 40);
			this.RadioButton2.Name = "RadioButton2";
			this.RadioButton2.Size = new System.Drawing.Size(56, 24);
			this.RadioButton2.TabIndex = 1;
			this.RadioButton2.Text = "11";
			this.RadioButton2.CheckedChanged += new System.EventHandler(this.RadioButton2_CheckedChanged);
			// 
			// RadioButton1
			// 
			this.RadioButton1.Checked = true;
			this.RadioButton1.Location = new System.Drawing.Point(16, 16);
			this.RadioButton1.Name = "RadioButton1";
			this.RadioButton1.Size = new System.Drawing.Size(56, 24);
			this.RadioButton1.TabIndex = 0;
			this.RadioButton1.TabStop = true;
			this.RadioButton1.Text = "8.25";
			this.RadioButton1.CheckedChanged += new System.EventHandler(this.RadioButton1_CheckedChanged);
			// 
			// TextBox2
			// 
			this.TextBox2.AutoSize = false;
			this.TextBox2.Location = new System.Drawing.Point(8, 96);
			this.TextBox2.Name = "TextBox2";
			this.TextBox2.ReadOnly = true;
			this.TextBox2.Size = new System.Drawing.Size(224, 20);
			this.TextBox2.TabIndex = 14;
			this.TextBox2.TabStop = false;
			this.TextBox2.Text = "Textbox with AutoSize = False";
			// 
			// TextBox1
			// 
			this.TextBox1.Location = new System.Drawing.Point(8, 72);
			this.TextBox1.Name = "TextBox1";
			this.TextBox1.ReadOnly = true;
			this.TextBox1.Size = new System.Drawing.Size(224, 20);
			this.TextBox1.TabIndex = 13;
			this.TextBox1.TabStop = false;
			this.TextBox1.Text = "Textbox with AutoSize = True";
			// 
			// Label2
			// 
			this.Label2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Label2.Location = new System.Drawing.Point(8, 40);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(152, 19);
			this.Label2.TabIndex = 12;
			this.Label2.Text = "Label with AutoSize = False";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Label1.Location = new System.Drawing.Point(8, 16);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(142, 19);
			this.Label1.TabIndex = 11;
			this.Label1.Text = "Label with AutoSize = True";
			// 
			// AutoSize
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 181);
			this.Controls.Add(this.Label4);
			this.Controls.Add(this.Panel3);
			this.Controls.Add(this.Button1);
			this.Controls.Add(this.TextBox3);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.TextBox2);
			this.Controls.Add(this.TextBox1);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.Panel2);
			this.Controls.Add(this.Panel1);
			this.Controls.Add(this.Label2);
			this.Name = "AutoSize";
			this.Text = "AutoSize";
			this.Panel3.ResumeLayout(false);
			this.Panel1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void RadioButton1_CheckedChanged(object sender, System.EventArgs e)
		{
			Font theFont = new Font(this.Font.FontFamily, (float)8.25);
			SizeF oldSize = GetAutoScaleSize(this.Font);
			SizeF newSize = GetAutoScaleSize(theFont);

			this.Font = theFont;

			if (doResize)  
				this.ScaleCore(newSize.Width / oldSize.Width, 
                newSize.Height / oldSize.Height);

		}

		private void RadioButton2_CheckedChanged(object sender, System.EventArgs e)
		{
			Font theFont = new Font(this.Font.FontFamily, (float)11.0);
			SizeF oldSize = GetAutoScaleSize(this.Font);
			SizeF newSize = GetAutoScaleSize(theFont);

			this.Font = theFont;

			if (doResize)  
				this.ScaleCore(newSize.Width / oldSize.Width, 
					newSize.Height / oldSize.Height);
		
		}

		private void RadioButton3_CheckedChanged(object sender, System.EventArgs e)
		{
			Font theFont = new Font(this.Font.FontFamily, (float)36.0);
			SizeF oldSize = GetAutoScaleSize(this.Font);
			SizeF newSize = GetAutoScaleSize(theFont);

			this.Font = theFont;

			if (doResize)  
				this.ScaleCore(newSize.Width / oldSize.Width, 
					newSize.Height / oldSize.Height);

		}

		private void cbManual_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.cbManual.Checked) 
			{
				this.AutoScale = false;
				doResize = true;
			}
			else
			{
				this.AutoScale = true;
				doResize = false;
			}

		}

		private void Button1_Click(object sender, System.EventArgs e)
		{
			this.Scale((float)1.1);
		}

	}
}
