using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataDisplayCSharp
{
	/// <summary>
	/// Summary description for CarryForward.
	/// </summary>
	public class CarryForward : System.Windows.Forms.Form
	{
		BindingManagerBase bmb;
		private int lastPosition;

		internal System.Data.OleDb.OleDbDataAdapter daCustomersExtended;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.OleDb.OleDbConnection cnNavigation;
		private DataDisplayCSharp.dsNavigation dsFrmNavigation;
		internal System.Windows.Forms.Panel pnlVideoButtons;
		internal System.Windows.Forms.Label lblNumRecords;
		internal System.Windows.Forms.TextBox tbCurrentRow;
		internal System.Windows.Forms.Button btnFirst;
		internal System.Windows.Forms.Button btnPrevious;
		internal System.Windows.Forms.Button btnNext;
		internal System.Windows.Forms.Button btnLast;
		internal System.Windows.Forms.Button btnNew;
		internal System.Windows.Forms.TextBox tbCustomerID;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox tbCustomerName;
		internal System.Windows.Forms.TextBox tbRepName;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public CarryForward()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.daCustomersExtended.Fill(this.dsFrmNavigation.CustomerListExtended);
			bmb = this.BindingContext[this.dsFrmNavigation, "CustomerListExtended"];

			this.btnFirst.Text = "|" + ((char)0x25C4).ToString();
			this.btnPrevious.Text = ((char)0x25C4).ToString();
			this.btnNext.Text = ((char)0x25BA).ToString();
			this.btnLast.Text = ((char)0x25BA).ToString() + "|";
			this.btnNew.Text = ((char)0x25BA).ToString() + "*";

			bmb.PositionChanged += new EventHandler(bmb_Changed);
			UpdateButtons();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		[STAThread]
		static void Main()
		{
			Application.Run(new CarryForward());
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.daCustomersExtended = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.cnNavigation = new System.Data.OleDb.OleDbConnection();
			this.dsFrmNavigation = new DataDisplayCSharp.dsNavigation();
			this.pnlVideoButtons = new System.Windows.Forms.Panel();
			this.lblNumRecords = new System.Windows.Forms.Label();
			this.tbCurrentRow = new System.Windows.Forms.TextBox();
			this.btnFirst = new System.Windows.Forms.Button();
			this.btnPrevious = new System.Windows.Forms.Button();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnLast = new System.Windows.Forms.Button();
			this.btnNew = new System.Windows.Forms.Button();
			this.tbCustomerID = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label3 = new System.Windows.Forms.Label();
			this.tbCustomerName = new System.Windows.Forms.TextBox();
			this.tbRepName = new System.Windows.Forms.TextBox();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmNavigation)).BeginInit();
			this.pnlVideoButtons.SuspendLayout();
			this.SuspendLayout();
			// 
			// daCustomersExtended
			// 
			this.daCustomersExtended.SelectCommand = this.OleDbSelectCommand1;
			this.daCustomersExtended.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										  new System.Data.Common.DataTableMapping("Table", "CustomerListExtended", new System.Data.Common.DataColumnMapping[] {
																																																								  new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																								  new System.Data.Common.DataColumnMapping("CustomerName", "CustomerName"),
																																																								  new System.Data.Common.DataColumnMapping("RepName", "RepName")})});
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT * FROM CustomerListExtended";
			this.OleDbSelectCommand1.Connection = this.cnNavigation;
			// 
			// cnNavigation
			// 
			this.cnNavigation.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\DataDisplay.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// dsFrmNavigation
			// 
			this.dsFrmNavigation.DataSetName = "dsNavigation";
			this.dsFrmNavigation.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// pnlVideoButtons
			// 
			this.pnlVideoButtons.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlVideoButtons.Controls.Add(this.lblNumRecords);
			this.pnlVideoButtons.Controls.Add(this.tbCurrentRow);
			this.pnlVideoButtons.Controls.Add(this.btnFirst);
			this.pnlVideoButtons.Controls.Add(this.btnPrevious);
			this.pnlVideoButtons.Controls.Add(this.btnNext);
			this.pnlVideoButtons.Controls.Add(this.btnLast);
			this.pnlVideoButtons.Controls.Add(this.btnNew);
			this.pnlVideoButtons.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlVideoButtons.Location = new System.Drawing.Point(0, 94);
			this.pnlVideoButtons.Name = "pnlVideoButtons";
			this.pnlVideoButtons.Size = new System.Drawing.Size(336, 40);
			this.pnlVideoButtons.TabIndex = 17;
			// 
			// lblNumRecords
			// 
			this.lblNumRecords.AutoSize = true;
			this.lblNumRecords.Location = new System.Drawing.Point(296, 11);
			this.lblNumRecords.Name = "lblNumRecords";
			this.lblNumRecords.Size = new System.Drawing.Size(22, 16);
			this.lblNumRecords.TabIndex = 2;
			this.lblNumRecords.Text = "of y";
			// 
			// tbCurrentRow
			// 
			this.tbCurrentRow.Location = new System.Drawing.Point(88, 8);
			this.tbCurrentRow.Name = "tbCurrentRow";
			this.tbCurrentRow.Size = new System.Drawing.Size(80, 20);
			this.tbCurrentRow.TabIndex = 1;
			this.tbCurrentRow.TabStop = false;
			this.tbCurrentRow.Text = "x";
			this.tbCurrentRow.Validating += new System.ComponentModel.CancelEventHandler(this.tbCurrentRow_Validating);
			// 
			// btnFirst
			// 
			this.btnFirst.BackColor = System.Drawing.SystemColors.Control;
			this.btnFirst.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnFirst.Location = new System.Drawing.Point(8, 8);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(32, 23);
			this.btnFirst.TabIndex = 0;
			this.btnFirst.TabStop = false;
			this.btnFirst.Text = "|<";
			this.btnFirst.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnFirst.Click += new System.EventHandler(this.btnFirst_Click);
			// 
			// btnPrevious
			// 
			this.btnPrevious.BackColor = System.Drawing.SystemColors.Control;
			this.btnPrevious.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPrevious.Location = new System.Drawing.Point(48, 8);
			this.btnPrevious.Name = "btnPrevious";
			this.btnPrevious.Size = new System.Drawing.Size(32, 23);
			this.btnPrevious.TabIndex = 0;
			this.btnPrevious.TabStop = false;
			this.btnPrevious.Text = "<";
			this.btnPrevious.Click += new System.EventHandler(this.btnPrevious_Click);
			// 
			// btnNext
			// 
			this.btnNext.BackColor = System.Drawing.SystemColors.Control;
			this.btnNext.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnNext.Location = new System.Drawing.Point(176, 8);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(32, 23);
			this.btnNext.TabIndex = 0;
			this.btnNext.TabStop = false;
			this.btnNext.Text = ">";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// btnLast
			// 
			this.btnLast.BackColor = System.Drawing.SystemColors.Control;
			this.btnLast.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLast.Location = new System.Drawing.Point(216, 8);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(32, 23);
			this.btnLast.TabIndex = 0;
			this.btnLast.TabStop = false;
			this.btnLast.Text = ">|";
			this.btnLast.Click += new System.EventHandler(this.btnLast_Click);
			// 
			// btnNew
			// 
			this.btnNew.BackColor = System.Drawing.SystemColors.Control;
			this.btnNew.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnNew.Location = new System.Drawing.Point(256, 8);
			this.btnNew.Name = "btnNew";
			this.btnNew.Size = new System.Drawing.Size(32, 23);
			this.btnNew.TabIndex = 0;
			this.btnNew.TabStop = false;
			this.btnNew.Text = ">*";
			this.btnNew.Click += new System.EventHandler(this.btnNew_Click);
			// 
			// tbCustomerID
			// 
			this.tbCustomerID.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmNavigation, "CustomerListExtended.CustomerID"));
			this.tbCustomerID.Location = new System.Drawing.Point(104, 8);
			this.tbCustomerID.Name = "tbCustomerID";
			this.tbCustomerID.Size = new System.Drawing.Size(152, 20);
			this.tbCustomerID.TabIndex = 11;
			this.tbCustomerID.Text = "CustomerID";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(8, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(68, 16);
			this.Label1.TabIndex = 14;
			this.Label1.Text = "CustomerID:";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(8, 32);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(87, 16);
			this.Label2.TabIndex = 15;
			this.Label2.Text = "CustomerName:";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(8, 56);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(58, 16);
			this.Label3.TabIndex = 12;
			this.Label3.Text = "RepName:";
			// 
			// tbCustomerName
			// 
			this.tbCustomerName.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmNavigation, "CustomerListExtended.CustomerName"));
			this.tbCustomerName.Location = new System.Drawing.Point(104, 32);
			this.tbCustomerName.Name = "tbCustomerName";
			this.tbCustomerName.Size = new System.Drawing.Size(152, 20);
			this.tbCustomerName.TabIndex = 13;
			this.tbCustomerName.Text = "CustomerName";
			this.tbCustomerName.Validated += new System.EventHandler(this.tbCustomerName_Validated);
			this.tbCustomerName.KeyUp += new System.Windows.Forms.KeyEventHandler(this.tbCustomerName_KeyUp);
			// 
			// tbRepName
			// 
			this.tbRepName.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmNavigation, "CustomerListExtended.RepName"));
			this.tbRepName.Location = new System.Drawing.Point(104, 56);
			this.tbRepName.Name = "tbRepName";
			this.tbRepName.Size = new System.Drawing.Size(152, 20);
			this.tbRepName.TabIndex = 16;
			this.tbRepName.Text = "RepName";
			// 
			// CarryForward
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 134);
			this.Controls.Add(this.pnlVideoButtons);
			this.Controls.Add(this.tbCustomerID);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.tbCustomerName);
			this.Controls.Add(this.tbRepName);
			this.Name = "CarryForward";
			this.Text = "CarryForward";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmNavigation)).EndInit();
			this.pnlVideoButtons.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		#region Navigation
		protected void UpdateButtons()
		{
			int pos = this.bmb.Position;

			if (pos == 0)
			{
				this.btnPrevious.Enabled = false;
				this.btnNext.Enabled = true;
			}
			else 
			{
				if (pos == (bmb.Count - 1))
				{
					this.btnNext.Enabled = false;
					this.btnPrevious.Enabled = true;
				}
				else
				{
					this.btnNext.Enabled = true;
					this.btnPrevious.Enabled = true;
				}
			}
			this.tbCurrentRow.Text = (this.bmb.Position + 1).ToString();
			this.lblNumRecords.Text = "of " + this.bmb.Count.ToString();

		}

		protected void bmb_Changed(Object sender, EventArgs e)
		{
			UpdateButtons();
		}

		private void btnFirst_Click(object sender, System.EventArgs e)
		{
			bmb.Position = 0;
		}

		private void btnPrevious_Click(object sender, System.EventArgs e)
		{
			bmb.Position -= 1;
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			bmb.Position += 1;
		}

		private void btnLast_Click(object sender, System.EventArgs e)
		{
			bmb.Position = bmb.Count - 1;
		}

		private void btnNew_Click(object sender, System.EventArgs e)
		{
			bmb.AddNew();
		}
		private void tbCurrentRow_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (this.tbCurrentRow.Text == "x")
			{
				this.tbCurrentRow.Text = (this.bmb.Position + 1).ToString();
				e.Cancel = true;
			}
			else
			{
				int row = int.Parse(this.tbCurrentRow.Text);
				if (row < 0) 
					this.tbCurrentRow.Text = "0";
				else
				{
					if (row > bmb.Count)
						this.tbCurrentRow.Text = bmb.Count.ToString();
				}
				this.bmb.Position = row - 1;
			}
		}
		#endregion

		private void tbCustomerName_Validated(object sender, System.EventArgs e)
		{
			if (((DataRowView)bmb.Current).Row.RowState == DataRowState.Detached)
			{
				DataColumn col = this.dsFrmNavigation.CustomerListExtended.CustomerNameColumn;
				col.DefaultValue = this.tbCustomerName.Text;
			}
		}

		private void tbCustomerName_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ((e.KeyCode == Keys.OemQuotes) & e.Control & e.Shift)
			{
				DataView dv = ((DataRowView)bmb.Current).DataView;
				dsNavigation.CustomerListExtendedRow row;
				row = dv[lastPosition].Row as dsNavigation.CustomerListExtendedRow;

				this.tbCustomerName.Text = row.CustomerName;
				e.Handled = true;
			}
		}

	}
}
