using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GDI_
{
	/// <summary>
	/// Summary description for DrawControl.
	/// </summary>
	public class DrawControl : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button btnClear;
		internal System.Windows.Forms.Button btnFillRevRect;
		internal System.Windows.Forms.Button btnStrDisabled;
		internal System.Windows.Forms.Button btnSizeGrip;
		internal System.Windows.Forms.Button btnSelFrame;
		internal System.Windows.Forms.Button btnScroll;
		internal System.Windows.Forms.Button btnRevLine;
		internal System.Windows.Forms.Button btnRevFrame;
		internal System.Windows.Forms.Button btnRadio;
		internal System.Windows.Forms.Button MixedCheck;
		internal System.Windows.Forms.Button btnMenuGlyph;
		internal System.Windows.Forms.Button btnLockedFrame;
		internal System.Windows.Forms.Button btnGrid;
		internal System.Windows.Forms.Button btnGrab;
		internal System.Windows.Forms.Button btnComboBtn;
		internal System.Windows.Forms.Button btnCheckBox;
		internal System.Windows.Forms.Button btnButton;
		internal System.Windows.Forms.Button btnCaption;
		internal System.Windows.Forms.Button btnBorder3D;
		internal System.Windows.Forms.Button btnBorder;
		internal System.Windows.Forms.Button btnFocusRectangle;
		internal System.Windows.Forms.Panel pnlDisplay;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DrawControl()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnClear = new System.Windows.Forms.Button();
			this.btnFillRevRect = new System.Windows.Forms.Button();
			this.btnStrDisabled = new System.Windows.Forms.Button();
			this.btnSizeGrip = new System.Windows.Forms.Button();
			this.btnSelFrame = new System.Windows.Forms.Button();
			this.btnScroll = new System.Windows.Forms.Button();
			this.btnRevLine = new System.Windows.Forms.Button();
			this.btnRevFrame = new System.Windows.Forms.Button();
			this.btnRadio = new System.Windows.Forms.Button();
			this.MixedCheck = new System.Windows.Forms.Button();
			this.btnMenuGlyph = new System.Windows.Forms.Button();
			this.btnLockedFrame = new System.Windows.Forms.Button();
			this.btnGrid = new System.Windows.Forms.Button();
			this.btnGrab = new System.Windows.Forms.Button();
			this.btnComboBtn = new System.Windows.Forms.Button();
			this.btnCheckBox = new System.Windows.Forms.Button();
			this.btnButton = new System.Windows.Forms.Button();
			this.btnCaption = new System.Windows.Forms.Button();
			this.btnBorder3D = new System.Windows.Forms.Button();
			this.btnBorder = new System.Windows.Forms.Button();
			this.btnFocusRectangle = new System.Windows.Forms.Button();
			this.pnlDisplay = new System.Windows.Forms.Panel();
			this.SuspendLayout();
			// 
			// btnClear
			// 
			this.btnClear.BackColor = System.Drawing.Color.White;
			this.btnClear.Location = new System.Drawing.Point(496, 200);
			this.btnClear.Name = "btnClear";
			this.btnClear.Size = new System.Drawing.Size(112, 23);
			this.btnClear.TabIndex = 20;
			this.btnClear.Text = "Clear";
			this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
			// 
			// btnFillRevRect
			// 
			this.btnFillRevRect.Location = new System.Drawing.Point(496, 168);
			this.btnFillRevRect.Name = "btnFillRevRect";
			this.btnFillRevRect.Size = new System.Drawing.Size(112, 23);
			this.btnFillRevRect.TabIndex = 19;
			this.btnFillRevRect.Text = "FillReversibleRect";
			this.btnFillRevRect.Click += new System.EventHandler(this.btnFillRevRect_Click);
			// 
			// btnStrDisabled
			// 
			this.btnStrDisabled.Location = new System.Drawing.Point(496, 136);
			this.btnStrDisabled.Name = "btnStrDisabled";
			this.btnStrDisabled.Size = new System.Drawing.Size(112, 23);
			this.btnStrDisabled.TabIndex = 18;
			this.btnStrDisabled.Text = "StringDisabled";
			this.btnStrDisabled.Click += new System.EventHandler(this.btnStrDisabled_Click);
			// 
			// btnSizeGrip
			// 
			this.btnSizeGrip.Location = new System.Drawing.Point(496, 104);
			this.btnSizeGrip.Name = "btnSizeGrip";
			this.btnSizeGrip.Size = new System.Drawing.Size(112, 23);
			this.btnSizeGrip.TabIndex = 17;
			this.btnSizeGrip.Text = "SizeGrip";
			this.btnSizeGrip.Click += new System.EventHandler(this.btnSizeGrip_Click);
			// 
			// btnSelFrame
			// 
			this.btnSelFrame.Location = new System.Drawing.Point(496, 72);
			this.btnSelFrame.Name = "btnSelFrame";
			this.btnSelFrame.Size = new System.Drawing.Size(112, 23);
			this.btnSelFrame.TabIndex = 16;
			this.btnSelFrame.Text = "SelectionFrame";
			this.btnSelFrame.Click += new System.EventHandler(this.btnSelFrame_Click);
			// 
			// btnScroll
			// 
			this.btnScroll.Location = new System.Drawing.Point(496, 40);
			this.btnScroll.Name = "btnScroll";
			this.btnScroll.Size = new System.Drawing.Size(112, 23);
			this.btnScroll.TabIndex = 15;
			this.btnScroll.Text = "ScrollButton";
			this.btnScroll.Click += new System.EventHandler(this.btnScroll_Click);
			// 
			// btnRevLine
			// 
			this.btnRevLine.Location = new System.Drawing.Point(496, 8);
			this.btnRevLine.Name = "btnRevLine";
			this.btnRevLine.Size = new System.Drawing.Size(112, 23);
			this.btnRevLine.TabIndex = 14;
			this.btnRevLine.Text = "ReversibleLine";
			this.btnRevLine.Click += new System.EventHandler(this.btnRevLine_Click);
			// 
			// btnRevFrame
			// 
			this.btnRevFrame.Location = new System.Drawing.Point(376, 200);
			this.btnRevFrame.Name = "btnRevFrame";
			this.btnRevFrame.Size = new System.Drawing.Size(112, 23);
			this.btnRevFrame.TabIndex = 13;
			this.btnRevFrame.Text = "ReversibleFrame";
			this.btnRevFrame.Click += new System.EventHandler(this.btnRevFrame_Click);
			// 
			// btnRadio
			// 
			this.btnRadio.Location = new System.Drawing.Point(376, 168);
			this.btnRadio.Name = "btnRadio";
			this.btnRadio.Size = new System.Drawing.Size(112, 23);
			this.btnRadio.TabIndex = 12;
			this.btnRadio.Text = "RadioButton";
			this.btnRadio.Click += new System.EventHandler(this.btnRadio_Click);
			// 
			// MixedCheck
			// 
			this.MixedCheck.Location = new System.Drawing.Point(376, 136);
			this.MixedCheck.Name = "MixedCheck";
			this.MixedCheck.Size = new System.Drawing.Size(112, 23);
			this.MixedCheck.TabIndex = 11;
			this.MixedCheck.Text = "MixedCheck";
			this.MixedCheck.Click += new System.EventHandler(this.MixedCheck_Click);
			// 
			// btnMenuGlyph
			// 
			this.btnMenuGlyph.Location = new System.Drawing.Point(376, 104);
			this.btnMenuGlyph.Name = "btnMenuGlyph";
			this.btnMenuGlyph.Size = new System.Drawing.Size(112, 23);
			this.btnMenuGlyph.TabIndex = 10;
			this.btnMenuGlyph.Text = "MenuGlyph";
			this.btnMenuGlyph.Click += new System.EventHandler(this.btnMenuGlyph_Click);
			// 
			// btnLockedFrame
			// 
			this.btnLockedFrame.Location = new System.Drawing.Point(376, 72);
			this.btnLockedFrame.Name = "btnLockedFrame";
			this.btnLockedFrame.Size = new System.Drawing.Size(112, 23);
			this.btnLockedFrame.TabIndex = 9;
			this.btnLockedFrame.Text = "LockedFrame";
			this.btnLockedFrame.Click += new System.EventHandler(this.btnLockedFrame_Click);
			// 
			// btnGrid
			// 
			this.btnGrid.Location = new System.Drawing.Point(376, 40);
			this.btnGrid.Name = "btnGrid";
			this.btnGrid.Size = new System.Drawing.Size(112, 23);
			this.btnGrid.TabIndex = 8;
			this.btnGrid.Text = "Grid";
			this.btnGrid.Click += new System.EventHandler(this.btnGrid_Click);
			// 
			// btnGrab
			// 
			this.btnGrab.Location = new System.Drawing.Point(376, 8);
			this.btnGrab.Name = "btnGrab";
			this.btnGrab.Size = new System.Drawing.Size(112, 23);
			this.btnGrab.TabIndex = 7;
			this.btnGrab.Text = "GrabHandle";
			this.btnGrab.Click += new System.EventHandler(this.btnGrab_Click);
			// 
			// btnComboBtn
			// 
			this.btnComboBtn.Location = new System.Drawing.Point(256, 168);
			this.btnComboBtn.Name = "btnComboBtn";
			this.btnComboBtn.Size = new System.Drawing.Size(112, 23);
			this.btnComboBtn.TabIndex = 5;
			this.btnComboBtn.Text = "ComboButton";
			this.btnComboBtn.Click += new System.EventHandler(this.btnComboBtn_Click);
			// 
			// btnCheckBox
			// 
			this.btnCheckBox.Location = new System.Drawing.Point(256, 136);
			this.btnCheckBox.Name = "btnCheckBox";
			this.btnCheckBox.Size = new System.Drawing.Size(112, 23);
			this.btnCheckBox.TabIndex = 4;
			this.btnCheckBox.Text = "CheckBox";
			this.btnCheckBox.Click += new System.EventHandler(this.btnCheckBox_Click);
			// 
			// btnButton
			// 
			this.btnButton.Location = new System.Drawing.Point(256, 72);
			this.btnButton.Name = "btnButton";
			this.btnButton.Size = new System.Drawing.Size(112, 23);
			this.btnButton.TabIndex = 2;
			this.btnButton.Text = "Button";
			this.btnButton.Click += new System.EventHandler(this.btnButton_Click);
			// 
			// btnCaption
			// 
			this.btnCaption.Location = new System.Drawing.Point(256, 104);
			this.btnCaption.Name = "btnCaption";
			this.btnCaption.Size = new System.Drawing.Size(112, 23);
			this.btnCaption.TabIndex = 3;
			this.btnCaption.Text = "CaptionButton";
			this.btnCaption.Click += new System.EventHandler(this.btnCaption_Click);
			// 
			// btnBorder3D
			// 
			this.btnBorder3D.Location = new System.Drawing.Point(256, 40);
			this.btnBorder3D.Name = "btnBorder3D";
			this.btnBorder3D.Size = new System.Drawing.Size(112, 23);
			this.btnBorder3D.TabIndex = 1;
			this.btnBorder3D.Text = "Border3D";
			this.btnBorder3D.Click += new System.EventHandler(this.btnBorder3D_Click);
			// 
			// btnBorder
			// 
			this.btnBorder.Location = new System.Drawing.Point(256, 8);
			this.btnBorder.Name = "btnBorder";
			this.btnBorder.Size = new System.Drawing.Size(112, 23);
			this.btnBorder.TabIndex = 0;
			this.btnBorder.Text = "Border";
			this.btnBorder.Click += new System.EventHandler(this.btnBorder_Click);
			// 
			// btnFocusRectangle
			// 
			this.btnFocusRectangle.Location = new System.Drawing.Point(256, 200);
			this.btnFocusRectangle.Name = "btnFocusRectangle";
			this.btnFocusRectangle.Size = new System.Drawing.Size(112, 23);
			this.btnFocusRectangle.TabIndex = 6;
			this.btnFocusRectangle.Text = "FocusRectangle";
			this.btnFocusRectangle.Click += new System.EventHandler(this.btnFocusRectangle_Click);
			// 
			// pnlDisplay
			// 
			this.pnlDisplay.BackColor = System.Drawing.Color.White;
			this.pnlDisplay.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlDisplay.Location = new System.Drawing.Point(8, 8);
			this.pnlDisplay.Name = "pnlDisplay";
			this.pnlDisplay.Size = new System.Drawing.Size(240, 216);
			this.pnlDisplay.TabIndex = 21;
			// 
			// DrawControl
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(616, 237);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnClear,
																		  this.btnFillRevRect,
																		  this.btnStrDisabled,
																		  this.btnSizeGrip,
																		  this.btnSelFrame,
																		  this.btnScroll,
																		  this.btnRevLine,
																		  this.btnRevFrame,
																		  this.btnRadio,
																		  this.MixedCheck,
																		  this.btnMenuGlyph,
																		  this.btnLockedFrame,
																		  this.btnGrid,
																		  this.btnGrab,
																		  this.btnComboBtn,
																		  this.btnCheckBox,
																		  this.btnButton,
																		  this.btnCaption,
																		  this.btnBorder3D,
																		  this.btnBorder,
																		  this.btnFocusRectangle,
																		  this.pnlDisplay});
			this.Name = "DrawControl";
			this.Text = "ControlPaint";
			this.ResumeLayout(false);

		}
		#endregion

		private void btnBorder_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

			ControlPaint.DrawBorder(grfx, rect, System.Drawing.Color.HotPink, ButtonBorderStyle.Outset);

			grfx.Dispose();
		}

		private void btnBorder3D_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

			ControlPaint.DrawBorder3D(grfx, rect, Border3DStyle.Sunken);

			grfx.Dispose();
		
		}

		private void btnButton_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawButton(grfx, rect, ButtonState.Pushed);

			grfx.Dispose();
		
		}

		private void btnCaption_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawCaptionButton(grfx, rect, CaptionButton.Close, ButtonState.Normal);

			grfx.Dispose();
		
		}

		private void btnCheckBox_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 15, 15);

	        ControlPaint.DrawCheckBox(grfx, rect, ButtonState.Checked);

			grfx.Dispose();
		
		}

		private void btnComboBtn_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 20, 20);

	        ControlPaint.DrawComboButton(grfx, rect, ButtonState.Normal);


			grfx.Dispose();
		}

		private void btnFocusRectangle_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawFocusRectangle(grfx, rect);

			grfx.Dispose();
		}

		private void btnGrab_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 5, 5);

	        ControlPaint.DrawGrabHandle(grfx, rect, true, true);

			grfx.Dispose();
	
		}

		private void btnGrid_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(1, 1, 200, 200);

	        ControlPaint.DrawGrid(grfx, rect, new Size(10, 10), System.Drawing.Color.White);

			grfx.Dispose();
		}

		private void btnLockedFrame_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawLockedFrame(grfx, rect, true);

			grfx.Dispose();
		
		}

		private void btnMenuGlyph_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawMenuGlyph(grfx, rect, MenuGlyph.Arrow);

			grfx.Dispose();
		}

		private void MixedCheck_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 10, 10);

	        ControlPaint.DrawMixedCheckBox(grfx, rect, ButtonState.Checked);

			grfx.Dispose();
		}

		private void btnRadio_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 15, 15);

	        ControlPaint.DrawRadioButton(grfx, rect, ButtonState.Checked);

			grfx.Dispose();
		}

		private void btnRevFrame_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 500, 200);

	        ControlPaint.DrawReversibleFrame(rect, System.Drawing.Color.Aqua, FrameStyle.Dashed);

			grfx.Dispose();
		}

		private void btnRevLine_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawReversibleLine( new Point(10, 10), new Point(100, 100), System.Drawing.Color.Aqua);

			grfx.Dispose();
		}

		private void btnScroll_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawScrollButton(grfx, rect, ScrollButton.Left, ButtonState.Normal);

			grfx.Dispose();
		}

		private void btnSelFrame_Click(object sender, System.EventArgs e)
		{
		
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rectInside = new Rectangle(10, 10, 50, 20);
			Rectangle rectOutside = new Rectangle(5, 5, 45, 15);

	        ControlPaint.DrawSelectionFrame(grfx, true, rectInside, rectOutside, System.Drawing.Color.Azure);

			grfx.Dispose();
		}

		private void btnSizeGrip_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.DrawSizeGrip(grfx, System.Drawing.Color.Blue, rect);

			grfx.Dispose();
		
		}

		private void btnStrDisabled_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			RectangleF rect = new Rectangle(0x10, 0x10, 0x50, 0x20);

			Font fnt = new Font("Tahoma", 11);

	        ControlPaint.DrawStringDisabled(grfx, "This is a test", fnt, System.Drawing.Color.Black, rect, System.Drawing.StringFormat.GenericTypographic);

			grfx.Dispose();
		
		}

		private void btnFillRevRect_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			Rectangle rect = new Rectangle(10, 10, 50, 20);

	        ControlPaint.FillReversibleRectangle(rect, System.Drawing.Color.Blue);

			grfx.Dispose();
		
		}

		private void btnClear_Click(object sender, System.EventArgs e)
		{
			Graphics grfx = this.pnlDisplay.CreateGraphics();
			grfx.Clear(System.Drawing.SystemColors.Control);
		}
	}
}
