using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Typography
{
	/// <summary>
	/// Summary description for FontExplorer.
	/// </summary>
	public class FontExplorer : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.TextBox txtLeadingInPoints;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.TextBox txtScale;
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.TextBox txtGetHeight;
		internal System.Windows.Forms.TextBox txtSizeInPoints;
		internal System.Windows.Forms.TextBox txtSize;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.TextBox txtHeight;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.TextBox txtLeading;
		internal System.Windows.Forms.TextBox txtLineSpacing;
		internal System.Windows.Forms.TextBox txtCellDescent;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.TextBox txtCellAscent;
		internal System.Windows.Forms.TextBox txtEmHeight;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox txtCharHeight;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.ListBox FontList;
		internal System.Windows.Forms.Label txtSample;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FontExplorer()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			int x;
			for (x = 0; x < FontFamily.Families.Length; x++)
				this.FontList.Items.Add(FontFamily.Families[x].Name);
       		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtLeadingInPoints = new System.Windows.Forms.TextBox();
			this.Label14 = new System.Windows.Forms.Label();
			this.txtScale = new System.Windows.Forms.TextBox();
			this.Label13 = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.txtGetHeight = new System.Windows.Forms.TextBox();
			this.txtSizeInPoints = new System.Windows.Forms.TextBox();
			this.txtSize = new System.Windows.Forms.TextBox();
			this.Label9 = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.Label11 = new System.Windows.Forms.Label();
			this.txtHeight = new System.Windows.Forms.TextBox();
			this.Label12 = new System.Windows.Forms.Label();
			this.Label7 = new System.Windows.Forms.Label();
			this.txtLeading = new System.Windows.Forms.TextBox();
			this.txtLineSpacing = new System.Windows.Forms.TextBox();
			this.txtCellDescent = new System.Windows.Forms.TextBox();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.txtCellAscent = new System.Windows.Forms.TextBox();
			this.txtEmHeight = new System.Windows.Forms.TextBox();
			this.Label5 = new System.Windows.Forms.Label();
			this.Label3 = new System.Windows.Forms.Label();
			this.txtCharHeight = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.FontList = new System.Windows.Forms.ListBox();
			this.txtSample = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// txtLeadingInPoints
			// 
			this.txtLeadingInPoints.Location = new System.Drawing.Point(520, 192);
			this.txtLeadingInPoints.Name = "txtLeadingInPoints";
			this.txtLeadingInPoints.Size = new System.Drawing.Size(96, 20);
			this.txtLeadingInPoints.TabIndex = 80;
			this.txtLeadingInPoints.Text = "LeadingInPoints";
			// 
			// Label14
			// 
			this.Label14.AutoSize = true;
			this.Label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label14.Location = new System.Drawing.Point(432, 192);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(73, 14);
			this.Label14.TabIndex = 79;
			this.Label14.Text = "Leading/Pts:";
			// 
			// txtScale
			// 
			this.txtScale.Location = new System.Drawing.Point(520, 160);
			this.txtScale.Name = "txtScale";
			this.txtScale.Size = new System.Drawing.Size(96, 20);
			this.txtScale.TabIndex = 78;
			this.txtScale.Text = "Scale";
			// 
			// Label13
			// 
			this.Label13.AutoSize = true;
			this.Label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label13.Location = new System.Drawing.Point(472, 160);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(39, 14);
			this.Label13.TabIndex = 77;
			this.Label13.Text = "Scale:";
			// 
			// Label8
			// 
			this.Label8.AutoSize = true;
			this.Label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label8.Location = new System.Drawing.Point(432, 8);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(90, 17);
			this.Label8.TabIndex = 76;
			this.Label8.Text = "Font Metrics";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(216, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(144, 17);
			this.Label1.TabIndex = 75;
			this.Label1.Text = "Font Family Metrics:";
			// 
			// txtGetHeight
			// 
			this.txtGetHeight.Location = new System.Drawing.Point(520, 128);
			this.txtGetHeight.Name = "txtGetHeight";
			this.txtGetHeight.Size = new System.Drawing.Size(96, 20);
			this.txtGetHeight.TabIndex = 74;
			this.txtGetHeight.Text = "GetHeight";
			// 
			// txtSizeInPoints
			// 
			this.txtSizeInPoints.Location = new System.Drawing.Point(520, 96);
			this.txtSizeInPoints.Name = "txtSizeInPoints";
			this.txtSizeInPoints.Size = new System.Drawing.Size(96, 20);
			this.txtSizeInPoints.TabIndex = 73;
			this.txtSizeInPoints.Text = "SizeInPoints";
			// 
			// txtSize
			// 
			this.txtSize.Location = new System.Drawing.Point(520, 64);
			this.txtSize.Name = "txtSize";
			this.txtSize.Size = new System.Drawing.Size(96, 20);
			this.txtSize.TabIndex = 72;
			this.txtSize.Text = "Size";
			// 
			// Label9
			// 
			this.Label9.AutoSize = true;
			this.Label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label9.Location = new System.Drawing.Point(480, 64);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(32, 14);
			this.Label9.TabIndex = 71;
			this.Label9.Text = "Size:";
			// 
			// Label10
			// 
			this.Label10.AutoSize = true;
			this.Label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label10.Location = new System.Drawing.Point(440, 128);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(64, 14);
			this.Label10.TabIndex = 70;
			this.Label10.Text = "GetHeight:";
			// 
			// Label11
			// 
			this.Label11.AutoSize = true;
			this.Label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label11.Location = new System.Drawing.Point(432, 96);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(73, 14);
			this.Label11.TabIndex = 69;
			this.Label11.Text = "SizeInPoints";
			// 
			// txtHeight
			// 
			this.txtHeight.Location = new System.Drawing.Point(520, 32);
			this.txtHeight.Name = "txtHeight";
			this.txtHeight.Size = new System.Drawing.Size(96, 20);
			this.txtHeight.TabIndex = 68;
			this.txtHeight.Text = "Height";
			// 
			// Label12
			// 
			this.Label12.AutoSize = true;
			this.Label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label12.Location = new System.Drawing.Point(464, 32);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(44, 14);
			this.Label12.TabIndex = 67;
			this.Label12.Text = "Height:";
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label7.Location = new System.Drawing.Point(240, 192);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(52, 14);
			this.Label7.TabIndex = 66;
			this.Label7.Text = "Leading:";
			// 
			// txtLeading
			// 
			this.txtLeading.Location = new System.Drawing.Point(312, 192);
			this.txtLeading.Name = "txtLeading";
			this.txtLeading.Size = new System.Drawing.Size(96, 20);
			this.txtLeading.TabIndex = 65;
			this.txtLeading.Text = "Leading";
			// 
			// txtLineSpacing
			// 
			this.txtLineSpacing.Location = new System.Drawing.Point(312, 128);
			this.txtLineSpacing.Name = "txtLineSpacing";
			this.txtLineSpacing.Size = new System.Drawing.Size(96, 20);
			this.txtLineSpacing.TabIndex = 64;
			this.txtLineSpacing.Text = "LineSpacing";
			// 
			// txtCellDescent
			// 
			this.txtCellDescent.Location = new System.Drawing.Point(312, 96);
			this.txtCellDescent.Name = "txtCellDescent";
			this.txtCellDescent.Size = new System.Drawing.Size(96, 20);
			this.txtCellDescent.TabIndex = 63;
			this.txtCellDescent.Text = "CellDescent";
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label6.Location = new System.Drawing.Point(216, 128);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(76, 14);
			this.Label6.TabIndex = 62;
			this.Label6.Text = "LineSpacing:";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label4.Location = new System.Drawing.Point(224, 96);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(75, 14);
			this.Label4.TabIndex = 61;
			this.Label4.Text = "CellDescent:";
			// 
			// txtCellAscent
			// 
			this.txtCellAscent.Location = new System.Drawing.Point(312, 64);
			this.txtCellAscent.Name = "txtCellAscent";
			this.txtCellAscent.Size = new System.Drawing.Size(96, 20);
			this.txtCellAscent.TabIndex = 60;
			this.txtCellAscent.Text = "CellAscent";
			// 
			// txtEmHeight
			// 
			this.txtEmHeight.Location = new System.Drawing.Point(312, 32);
			this.txtEmHeight.Name = "txtEmHeight";
			this.txtEmHeight.Size = new System.Drawing.Size(96, 20);
			this.txtEmHeight.TabIndex = 59;
			this.txtEmHeight.Text = "EmHeight";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label5.Location = new System.Drawing.Point(232, 32);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(62, 14);
			this.Label5.TabIndex = 58;
			this.Label5.Text = "EmHeight:";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.Location = new System.Drawing.Point(232, 64);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(67, 14);
			this.Label3.TabIndex = 57;
			this.Label3.Text = "CellAscent:";
			// 
			// txtCharHeight
			// 
			this.txtCharHeight.Location = new System.Drawing.Point(312, 160);
			this.txtCharHeight.Name = "txtCharHeight";
			this.txtCharHeight.Size = new System.Drawing.Size(96, 20);
			this.txtCharHeight.TabIndex = 56;
			this.txtCharHeight.Text = "CharHeight";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.Location = new System.Drawing.Point(216, 160);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(71, 14);
			this.Label2.TabIndex = 55;
			this.Label2.Text = "CharHeight:";
			// 
			// FontList
			// 
			this.FontList.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FontList.ItemHeight = 15;
			this.FontList.Location = new System.Drawing.Point(8, 8);
			this.FontList.Name = "FontList";
			this.FontList.Size = new System.Drawing.Size(200, 289);
			this.FontList.TabIndex = 53;
			this.FontList.SelectedIndexChanged += new System.EventHandler(this.FontList_SelectedIndexChanged);
			// 
			// txtSample
			// 
			this.txtSample.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.txtSample.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.txtSample.Font = new System.Drawing.Font("Microsoft Sans Serif", 18F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.txtSample.Location = new System.Drawing.Point(224, 232);
			this.txtSample.Name = "txtSample";
			this.txtSample.Size = new System.Drawing.Size(392, 64);
			this.txtSample.TabIndex = 54;
			this.txtSample.Text = "The quick brown fox jumped over the lazy yellow dog";
			// 
			// FontExplorer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(640, 309);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.txtLeadingInPoints,
																		  this.Label14,
																		  this.txtScale,
																		  this.Label13,
																		  this.Label8,
																		  this.Label1,
																		  this.txtGetHeight,
																		  this.txtSizeInPoints,
																		  this.txtSize,
																		  this.Label9,
																		  this.Label10,
																		  this.Label11,
																		  this.txtHeight,
																		  this.Label12,
																		  this.Label7,
																		  this.txtLeading,
																		  this.txtLineSpacing,
																		  this.txtCellDescent,
																		  this.Label6,
																		  this.Label4,
																		  this.txtCellAscent,
																		  this.txtEmHeight,
																		  this.Label5,
																		  this.Label3,
																		  this.txtCharHeight,
																		  this.Label2,
																		  this.FontList,
																		  this.txtSample});
			this.Name = "FontExplorer";
			this.Text = "FontExplorer";
			this.ResumeLayout(false);

		}
		#endregion

		private void FontList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			FontFamily ffCurrent;
			Font fntCurrent;
			Single charHeight;
			Single leading;
			Single scale; 
			FontStyle fs; 

			ffCurrent = new FontFamily(this.FontList.SelectedItem.ToString());
			//check for regular style
			fs = FontStyle.Regular;
			fntCurrent = new Font(ffCurrent, 18, FontStyle.Regular);
			

			charHeight = ffCurrent.GetCellAscent(FontStyle.Regular) + ffCurrent.GetCellDescent(FontStyle.Regular);
			leading = ffCurrent.GetLineSpacing(FontStyle.Regular) - charHeight;
			scale = fntCurrent.SizeInPoints / ffCurrent.GetEmHeight(FontStyle.Regular);

			this.txtSample.Font = fntCurrent;

			this.txtCharHeight.Text = charHeight.ToString();
			this.txtCellAscent.Text = (ffCurrent.GetCellAscent(FontStyle.Regular)).ToString();
			this.txtCellDescent.Text = (ffCurrent.GetCellDescent(FontStyle.Regular)).ToString();
			this.txtEmHeight.Text = (ffCurrent.GetEmHeight(FontStyle.Regular)).ToString();
			this.txtLeading.Text = leading.ToString();
			this.txtLineSpacing.Text = (ffCurrent.GetLineSpacing(FontStyle.Regular)).ToString();
			this.txtHeight.Text = (fntCurrent.Height).ToString();
			this.txtSize.Text = (fntCurrent.Size).ToString();
			this.txtSizeInPoints.Text = (fntCurrent.SizeInPoints).ToString();
			this.txtGetHeight.Text = (fntCurrent.GetHeight()).ToString();
			this.txtScale.Text = scale.ToString();
			this.txtLeadingInPoints.Text = (leading * scale).ToString();
		}
	}
}
