using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ComplexLayoutsCSharp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Button btnLast;
		internal System.Windows.Forms.ImageList RecordButtons;
		internal System.Windows.Forms.Button btnNext;
		internal System.Windows.Forms.TextBox txtStatus;
		internal System.Windows.Forms.Label Label9;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand3;
		internal System.Data.OleDb.OleDbConnection cnBooks;
		internal System.Data.OleDb.OleDbDataAdapter daHistory;
		internal System.Data.OleDb.OleDbDataAdapter daReference;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand4;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Windows.Forms.Button btnPrevious;
		internal System.Data.OleDb.OleDbDataAdapter daFiction;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Windows.Forms.Button btnFirst;
		internal System.Data.OleDb.OleDbDataAdapter daBooks;
		private ComplexLayoutsCSharp.dsBookMaster dsBookMaster;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Panel pnlFiction;
		internal System.Windows.Forms.TextBox tbSeries;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.TextBox tbType;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.TextBox tbSubtitle;
		internal System.Windows.Forms.TextBox tbTitle;
		internal System.Windows.Forms.TextBox tbID;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Panel pnlHistory;
		internal System.Windows.Forms.TextBox tbEra;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Panel pnlReference;
		internal System.Windows.Forms.TextBox TextBox1;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.TextBox TextBox2;
		internal System.Windows.Forms.Label Label8;
		private System.ComponentModel.IContainer components;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
            this.daBooks.Fill(this.dsBookMaster.Books);
            this.daFiction.Fill(this.dsBookMaster.Fiction);
            this.daReference.Fill(this.dsBookMaster.Reference);
			this.daHistory.Fill(this.dsBookMaster.History);
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}

        UpdateDisplay();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.btnLast = new System.Windows.Forms.Button();
			this.RecordButtons = new System.Windows.Forms.ImageList(this.components);
			this.btnNext = new System.Windows.Forms.Button();
			this.txtStatus = new System.Windows.Forms.TextBox();
			this.Label9 = new System.Windows.Forms.Label();
			this.OleDbSelectCommand3 = new System.Data.OleDb.OleDbCommand();
			this.cnBooks = new System.Data.OleDb.OleDbConnection();
			this.daHistory = new System.Data.OleDb.OleDbDataAdapter();
			this.daReference = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand4 = new System.Data.OleDb.OleDbCommand();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.btnPrevious = new System.Windows.Forms.Button();
			this.daFiction = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.btnFirst = new System.Windows.Forms.Button();
			this.daBooks = new System.Data.OleDb.OleDbDataAdapter();
			this.dsBookMaster = new ComplexLayoutsCSharp.dsBookMaster();
			this.Label4 = new System.Windows.Forms.Label();
			this.pnlFiction = new System.Windows.Forms.Panel();
			this.tbSeries = new System.Windows.Forms.TextBox();
			this.Label6 = new System.Windows.Forms.Label();
			this.tbType = new System.Windows.Forms.TextBox();
			this.Label5 = new System.Windows.Forms.Label();
			this.tbSubtitle = new System.Windows.Forms.TextBox();
			this.tbTitle = new System.Windows.Forms.TextBox();
			this.tbID = new System.Windows.Forms.TextBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.pnlHistory = new System.Windows.Forms.Panel();
			this.tbEra = new System.Windows.Forms.TextBox();
			this.Label10 = new System.Windows.Forms.Label();
			this.pnlReference = new System.Windows.Forms.Panel();
			this.TextBox1 = new System.Windows.Forms.TextBox();
			this.Label7 = new System.Windows.Forms.Label();
			this.TextBox2 = new System.Windows.Forms.TextBox();
			this.Label8 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsBookMaster)).BeginInit();
			this.pnlFiction.SuspendLayout();
			this.pnlHistory.SuspendLayout();
			this.pnlReference.SuspendLayout();
			this.SuspendLayout();
			// 
			// btnLast
			// 
			this.btnLast.BackColor = System.Drawing.Color.White;
			this.btnLast.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLast.ImageIndex = 2;
			this.btnLast.ImageList = this.RecordButtons;
			this.btnLast.Location = new System.Drawing.Point(176, 248);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(20, 20);
			this.btnLast.TabIndex = 32;
			this.btnLast.Click += new System.EventHandler(this.btnLast_Click);
			// 
			// RecordButtons
			// 
			this.RecordButtons.ImageSize = new System.Drawing.Size(15, 13);
			this.RecordButtons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("RecordButtons.ImageStream")));
			this.RecordButtons.TransparentColor = System.Drawing.Color.White;
			// 
			// btnNext
			// 
			this.btnNext.BackColor = System.Drawing.Color.White;
			this.btnNext.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnNext.ImageIndex = 6;
			this.btnNext.ImageList = this.RecordButtons;
			this.btnNext.Location = new System.Drawing.Point(160, 248);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(20, 20);
			this.btnNext.TabIndex = 31;
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// txtStatus
			// 
			this.txtStatus.Location = new System.Drawing.Point(104, 244);
			this.txtStatus.Name = "txtStatus";
			this.txtStatus.Size = new System.Drawing.Size(48, 20);
			this.txtStatus.TabIndex = 30;
			this.txtStatus.Text = "x of y";
			// 
			// Label9
			// 
			this.Label9.AutoSize = true;
			this.Label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label9.Location = new System.Drawing.Point(8, 252);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(44, 16);
			this.Label9.TabIndex = 28;
			this.Label9.Text = "Record:";
			// 
			// OleDbSelectCommand3
			// 
			this.OleDbSelectCommand3.CommandText = "SELECT BookID, Era FROM History";
			this.OleDbSelectCommand3.Connection = this.cnBooks;
			// 
			// cnBooks
			// 
			this.cnBooks.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Books.mdb"";Mode=Share Deny None;Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// daHistory
			// 
			this.daHistory.SelectCommand = this.OleDbSelectCommand3;
			this.daHistory.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								new System.Data.Common.DataTableMapping("Table", "History", new System.Data.Common.DataColumnMapping[] {
																																																		   new System.Data.Common.DataColumnMapping("BookID", "BookID"),
																																																		   new System.Data.Common.DataColumnMapping("Era", "Era")})});
			// 
			// daReference
			// 
			this.daReference.SelectCommand = this.OleDbSelectCommand4;
			this.daReference.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								  new System.Data.Common.DataTableMapping("Table", "Reference", new System.Data.Common.DataColumnMapping[] {
																																																			   new System.Data.Common.DataColumnMapping("BookID", "BookID"),
																																																			   new System.Data.Common.DataColumnMapping("ReferenceType", "ReferenceType"),
																																																			   new System.Data.Common.DataColumnMapping("Subject", "Subject")})});
			// 
			// OleDbSelectCommand4
			// 
			this.OleDbSelectCommand4.CommandText = "SELECT BookID, ReferenceType, Subject FROM Reference";
			this.OleDbSelectCommand4.Connection = this.cnBooks;
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT BookID, BookTypeID, Subtitle, Title FROM Books";
			this.OleDbSelectCommand1.Connection = this.cnBooks;
			// 
			// btnPrevious
			// 
			this.btnPrevious.BackColor = System.Drawing.Color.White;
			this.btnPrevious.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPrevious.ImageIndex = 8;
			this.btnPrevious.ImageList = this.RecordButtons;
			this.btnPrevious.Location = new System.Drawing.Point(80, 248);
			this.btnPrevious.Name = "btnPrevious";
			this.btnPrevious.Size = new System.Drawing.Size(20, 20);
			this.btnPrevious.TabIndex = 29;
			this.btnPrevious.Click += new System.EventHandler(this.btnPrevious_Click);
			// 
			// daFiction
			// 
			this.daFiction.SelectCommand = this.OleDbSelectCommand2;
			this.daFiction.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								new System.Data.Common.DataTableMapping("Table", "Fiction", new System.Data.Common.DataColumnMapping[] {
																																																		   new System.Data.Common.DataColumnMapping("BookID", "BookID"),
																																																		   new System.Data.Common.DataColumnMapping("Category", "Category"),
																																																		   new System.Data.Common.DataColumnMapping("SeriesName", "SeriesName")})});
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT BookID, Category, SeriesName FROM Fiction";
			this.OleDbSelectCommand2.Connection = this.cnBooks;
			// 
			// btnFirst
			// 
			this.btnFirst.BackColor = System.Drawing.Color.White;
			this.btnFirst.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnFirst.ImageIndex = 0;
			this.btnFirst.ImageList = this.RecordButtons;
			this.btnFirst.Location = new System.Drawing.Point(64, 248);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(20, 20);
			this.btnFirst.TabIndex = 27;
			this.btnFirst.Click += new System.EventHandler(this.btnFirst_Click);
			// 
			// daBooks
			// 
			this.daBooks.SelectCommand = this.OleDbSelectCommand1;
			this.daBooks.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							  new System.Data.Common.DataTableMapping("Table", "Books", new System.Data.Common.DataColumnMapping[] {
																																																	   new System.Data.Common.DataColumnMapping("BookID", "BookID"),
																																																	   new System.Data.Common.DataColumnMapping("BookTypeID", "BookTypeID"),
																																																	   new System.Data.Common.DataColumnMapping("Subtitle", "Subtitle"),
																																																	   new System.Data.Common.DataColumnMapping("Title", "Title")})});
			// 
			// dsBookMaster
			// 
			this.dsBookMaster.DataSetName = "dsBookMaster";
			this.dsBookMaster.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Location = new System.Drawing.Point(96, 112);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(88, 16);
			this.Label4.TabIndex = 40;
			this.Label4.Text = "Category Details";
			// 
			// pnlFiction
			// 
			this.pnlFiction.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlFiction.Controls.Add(this.tbSeries);
			this.pnlFiction.Controls.Add(this.Label6);
			this.pnlFiction.Controls.Add(this.tbType);
			this.pnlFiction.Controls.Add(this.Label5);
			this.pnlFiction.Location = new System.Drawing.Point(96, 136);
			this.pnlFiction.Name = "pnlFiction";
			this.pnlFiction.Size = new System.Drawing.Size(448, 96);
			this.pnlFiction.TabIndex = 39;
			// 
			// tbSeries
			// 
			this.tbSeries.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.BooksFiction.SeriesName"));
			this.tbSeries.Location = new System.Drawing.Point(88, 40);
			this.tbSeries.Name = "tbSeries";
			this.tbSeries.Size = new System.Drawing.Size(304, 20);
			this.tbSeries.TabIndex = 7;
			this.tbSeries.Text = "Series";
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label6.Location = new System.Drawing.Point(26, 42);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(54, 20);
			this.Label6.TabIndex = 6;
			this.Label6.Text = "Series:";
			// 
			// tbType
			// 
			this.tbType.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.BooksFiction.Category"));
			this.tbType.Location = new System.Drawing.Point(88, 8);
			this.tbType.Name = "tbType";
			this.tbType.Size = new System.Drawing.Size(304, 20);
			this.tbType.TabIndex = 5;
			this.tbType.Text = "Category";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label5.Location = new System.Drawing.Point(8, 10);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(72, 20);
			this.Label5.TabIndex = 4;
			this.Label5.Text = "Category:";
			// 
			// tbSubtitle
			// 
			this.tbSubtitle.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.Subtitle"));
			this.tbSubtitle.Location = new System.Drawing.Point(96, 72);
			this.tbSubtitle.Name = "tbSubtitle";
			this.tbSubtitle.Size = new System.Drawing.Size(448, 20);
			this.tbSubtitle.TabIndex = 38;
			this.tbSubtitle.Text = "Subtitle";
			// 
			// tbTitle
			// 
			this.tbTitle.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.Title"));
			this.tbTitle.Location = new System.Drawing.Point(96, 40);
			this.tbTitle.Name = "tbTitle";
			this.tbTitle.Size = new System.Drawing.Size(448, 20);
			this.tbTitle.TabIndex = 37;
			this.tbTitle.Text = "Title";
			// 
			// tbID
			// 
			this.tbID.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.BookID"));
			this.tbID.Location = new System.Drawing.Point(96, 8);
			this.tbID.Name = "tbID";
			this.tbID.Size = new System.Drawing.Size(40, 20);
			this.tbID.TabIndex = 36;
			this.tbID.Text = "ID";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.Location = new System.Drawing.Point(16, 80);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(62, 20);
			this.Label3.TabIndex = 35;
			this.Label3.Text = "Subtitle:";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.Location = new System.Drawing.Point(40, 48);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(39, 20);
			this.Label2.TabIndex = 34;
			this.Label2.Text = "Title:";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(56, 16);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(25, 20);
			this.Label1.TabIndex = 33;
			this.Label1.Text = "ID:";
			// 
			// pnlHistory
			// 
			this.pnlHistory.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlHistory.Controls.Add(this.tbEra);
			this.pnlHistory.Controls.Add(this.Label10);
			this.pnlHistory.Location = new System.Drawing.Point(96, 136);
			this.pnlHistory.Name = "pnlHistory";
			this.pnlHistory.Size = new System.Drawing.Size(448, 100);
			this.pnlHistory.TabIndex = 42;
			// 
			// tbEra
			// 
			this.tbEra.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.BooksHistory.Era"));
			this.tbEra.Location = new System.Drawing.Point(88, 8);
			this.tbEra.Name = "tbEra";
			this.tbEra.Size = new System.Drawing.Size(304, 20);
			this.tbEra.TabIndex = 5;
			this.tbEra.Text = "Era";
			// 
			// Label10
			// 
			this.Label10.AutoSize = true;
			this.Label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label10.Location = new System.Drawing.Point(24, 16);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(34, 20);
			this.Label10.TabIndex = 4;
			this.Label10.Text = "Era:";
			// 
			// pnlReference
			// 
			this.pnlReference.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pnlReference.Controls.Add(this.TextBox1);
			this.pnlReference.Controls.Add(this.Label7);
			this.pnlReference.Controls.Add(this.TextBox2);
			this.pnlReference.Controls.Add(this.Label8);
			this.pnlReference.Location = new System.Drawing.Point(96, 136);
			this.pnlReference.Name = "pnlReference";
			this.pnlReference.Size = new System.Drawing.Size(448, 100);
			this.pnlReference.TabIndex = 41;
			// 
			// TextBox1
			// 
			this.TextBox1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.BooksReference.Subject"));
			this.TextBox1.Location = new System.Drawing.Point(88, 40);
			this.TextBox1.Name = "TextBox1";
			this.TextBox1.Size = new System.Drawing.Size(304, 20);
			this.TextBox1.TabIndex = 7;
			this.TextBox1.Text = "Subject";
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label7.Location = new System.Drawing.Point(16, 42);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(61, 20);
			this.Label7.TabIndex = 6;
			this.Label7.Text = "Subject:";
			// 
			// TextBox2
			// 
			this.TextBox2.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsBookMaster, "Books.BooksReference.ReferenceType"));
			this.TextBox2.Location = new System.Drawing.Point(88, 8);
			this.TextBox2.Name = "TextBox2";
			this.TextBox2.Size = new System.Drawing.Size(304, 20);
			this.TextBox2.TabIndex = 5;
			this.TextBox2.Text = "ReferenceType";
			// 
			// Label8
			// 
			this.Label8.AutoSize = true;
			this.Label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 11.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label8.Location = new System.Drawing.Point(33, 10);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(44, 20);
			this.Label8.TabIndex = 4;
			this.Label8.Text = "Type:";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 277);
			this.Controls.Add(this.Label4);
			this.Controls.Add(this.pnlFiction);
			this.Controls.Add(this.tbSubtitle);
			this.Controls.Add(this.tbTitle);
			this.Controls.Add(this.tbID);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.pnlHistory);
			this.Controls.Add(this.pnlReference);
			this.Controls.Add(this.btnLast);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.txtStatus);
			this.Controls.Add(this.Label9);
			this.Controls.Add(this.btnPrevious);
			this.Controls.Add(this.btnFirst);
			this.Name = "Form1";
			this.Text = "Book Panel";
			((System.ComponentModel.ISupportInitialize)(this.dsBookMaster)).EndInit();
			this.pnlFiction.ResumeLayout(false);
			this.pnlHistory.ResumeLayout(false);
			this.pnlReference.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void UpdateDisplay()
		{
			int bkType;
			dsBookMaster.BooksRow dr;
			BindingManagerBase bc = this.BindingContext[this.dsBookMaster, "Books"];

			dr = this.dsBookMaster.Books.DefaultView[bc.Position].Row as dsBookMaster.BooksRow;
			bkType = dr.BookTypeID;

			this.pnlFiction.Visible = false;
			this.pnlHistory.Visible  = false;
			this.pnlReference.Visible = false;

			switch (bkType)
			{
				case 1: //fiction
					this.pnlFiction.Visible = true;
					break;
				case 2: //reference
					this.pnlReference.Visible = true;
					break;
				case 3: //history
					this.pnlHistory.Visible = true;
					break;
			}

		}

		private void btnFirst_Click(object sender, System.EventArgs e)
		{
	        BindingManagerBase bmb = this.BindingContext[this.dsBookMaster, "Books"];
	        bmb.Position = 0;
		    UpdateDisplay();

		}

		private void btnPrevious_Click(object sender, System.EventArgs e)
		{
			BindingManagerBase bmb = this.BindingContext[this.dsBookMaster, "Books"];
			bmb.Position -= 1;
			UpdateDisplay();
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			BindingManagerBase bmb = this.BindingContext[this.dsBookMaster, "Books"];
			bmb.Position += 1;
			UpdateDisplay();
		}

		private void btnLast_Click(object sender, System.EventArgs e)
		{
			BindingManagerBase bmb = this.BindingContext[this.dsBookMaster, "Books"];
			bmb.Position = bmb.Count;
			UpdateDisplay();
		}
	}
}
