using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace NumbersAndTextCSharp
{
	/// <summary>
	/// Summary description for FormatText.
	/// </summary>
	public class FormatText : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.RichTextBox RichTextBox1;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.TextBox tbTitle;
		internal System.Windows.Forms.Button btnPrevious;
		internal System.Windows.Forms.TextBox tbSSN;
		internal System.Windows.Forms.Label tbRowID;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Button btnNext;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox tbCalc;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.OleDb.OleDbConnection cnTextAndNumbers;
		internal System.Data.OleDb.OleDbDataAdapter daFormatting;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.TextBox tbCharOnly;
		private NumbersAndTextCSharp.dsFormatting dsFrmFormatting;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public FormatText()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.daFormatting.Fill(this.dsFrmFormatting);

			Binding b;
			b = this.tbSSN.DataBindings["Text"];
			b.Format += new ConvertEventHandler(FormatSSN);
			b.Parse += new ConvertEventHandler(ParseSSN);
			
			BindingManagerBase bmb = this.BindingContext[this.dsFrmFormatting, "Formatting"];
			bmb.PositionChanged += new EventHandler(FormatChange);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.RichTextBox1 = new System.Windows.Forms.RichTextBox();
			this.Label4 = new System.Windows.Forms.Label();
			this.tbTitle = new System.Windows.Forms.TextBox();
			this.btnPrevious = new System.Windows.Forms.Button();
			this.tbSSN = new System.Windows.Forms.TextBox();
			this.tbRowID = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.btnNext = new System.Windows.Forms.Button();
			this.Label3 = new System.Windows.Forms.Label();
			this.tbCalc = new System.Windows.Forms.TextBox();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.cnTextAndNumbers = new System.Data.OleDb.OleDbConnection();
			this.daFormatting = new System.Data.OleDb.OleDbDataAdapter();
			this.Label5 = new System.Windows.Forms.Label();
			this.tbCharOnly = new System.Windows.Forms.TextBox();
			this.dsFrmFormatting = new NumbersAndTextCSharp.dsFormatting();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmFormatting)).BeginInit();
			this.SuspendLayout();
			// 
			// RichTextBox1
			// 
			this.RichTextBox1.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmFormatting, "Formatting.titleString"));
			this.RichTextBox1.Location = new System.Drawing.Point(248, 16);
			this.RichTextBox1.Name = "RichTextBox1";
			this.RichTextBox1.Size = new System.Drawing.Size(208, 152);
			this.RichTextBox1.TabIndex = 4;
			this.RichTextBox1.Text = "RichTextBox1";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Location = new System.Drawing.Point(24, 112);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(58, 16);
			this.Label4.TabIndex = 17;
			this.Label4.Text = "Title Case:";
			// 
			// tbTitle
			// 
			this.tbTitle.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmFormatting, "Formatting.titleString"));
			this.tbTitle.Location = new System.Drawing.Point(120, 112);
			this.tbTitle.MaxLength = 25;
			this.tbTitle.Name = "tbTitle";
			this.tbTitle.TabIndex = 2;
			this.tbTitle.Text = "TITLE CASE";
			this.tbTitle.Leave += new System.EventHandler(this.tbTitle_Leave);
			// 
			// btnPrevious
			// 
			this.btnPrevious.Location = new System.Drawing.Point(8, 176);
			this.btnPrevious.Name = "btnPrevious";
			this.btnPrevious.Size = new System.Drawing.Size(24, 23);
			this.btnPrevious.TabIndex = 5;
			this.btnPrevious.Text = "<";
			this.btnPrevious.Click += new System.EventHandler(this.btnPrevious_Click);
			// 
			// tbSSN
			// 
			this.tbSSN.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmFormatting, "Formatting.ssn"));
			this.tbSSN.Location = new System.Drawing.Point(120, 48);
			this.tbSSN.Name = "tbSSN";
			this.tbSSN.TabIndex = 0;
			this.tbSSN.Text = "SSN";
			// 
			// tbRowID
			// 
			this.tbRowID.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.tbRowID.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmFormatting, "Formatting.RowID"));
			this.tbRowID.Location = new System.Drawing.Point(72, 16);
			this.tbRowID.Name = "tbRowID";
			this.tbRowID.Size = new System.Drawing.Size(48, 16);
			this.tbRowID.TabIndex = 10;
			this.tbRowID.Text = "RowID";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(24, 16);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(44, 16);
			this.Label1.TabIndex = 8;
			this.Label1.Text = "Row ID:";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(24, 48);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(85, 16);
			this.Label2.TabIndex = 7;
			this.Label2.Text = "Formatted SSN:";
			// 
			// btnNext
			// 
			this.btnNext.Location = new System.Drawing.Point(40, 176);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(24, 23);
			this.btnNext.TabIndex = 6;
			this.btnNext.Text = ">";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(24, 80);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(87, 16);
			this.Label3.TabIndex = 9;
			this.Label3.Text = "Calculated SSN:";
			// 
			// tbCalc
			// 
			this.tbCalc.Enabled = false;
			this.tbCalc.Location = new System.Drawing.Point(120, 80);
			this.tbCalc.Name = "tbCalc";
			this.tbCalc.TabIndex = 1;
			this.tbCalc.Text = "SSN";
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT * FROM Formatting";
			this.OleDbSelectCommand1.Connection = this.cnTextAndNumbers;
			// 
			// cnTextAndNumbers
			// 
			this.cnTextAndNumbers.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""C:\Documents and Settings\Rebecca M. Riordan\My Documents\My Projects\Writing\Technical\Finished\Seeing Data\06 - Sample Code\12\NumbersAndTextVB\NumbersAndCurrency.mdb"";Mode=Share Deny None;Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// daFormatting
			// 
			this.daFormatting.SelectCommand = this.OleDbSelectCommand1;
			this.daFormatting.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								   new System.Data.Common.DataTableMapping("Table", "Formatting", new System.Data.Common.DataColumnMapping[] {
																																																				 new System.Data.Common.DataColumnMapping("RowID", "RowID"),
																																																				 new System.Data.Common.DataColumnMapping("ssn", "ssn")})});
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Location = new System.Drawing.Point(24, 144);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(55, 16);
			this.Label5.TabIndex = 16;
			this.Label5.Text = "Keypress:";
			// 
			// tbCharOnly
			// 
			this.tbCharOnly.Location = new System.Drawing.Point(120, 144);
			this.tbCharOnly.MaxLength = 25;
			this.tbCharOnly.Name = "tbCharOnly";
			this.tbCharOnly.TabIndex = 3;
			this.tbCharOnly.Text = "char only";
			this.tbCharOnly.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.tbCharOnly_Keypress);
			// 
			// dsFrmFormatting
			// 
			this.dsFrmFormatting.DataSetName = "dsFormatting";
			this.dsFrmFormatting.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// FormatText
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 205);
			this.Controls.Add(this.tbTitle);
			this.Controls.Add(this.btnPrevious);
			this.Controls.Add(this.tbSSN);
			this.Controls.Add(this.tbRowID);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.tbCalc);
			this.Controls.Add(this.Label5);
			this.Controls.Add(this.tbCharOnly);
			this.Controls.Add(this.RichTextBox1);
			this.Controls.Add(this.Label4);
			this.Name = "FormatText";
			this.Text = "FormatText";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmFormatting)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void FormatSSN(Object sender, ConvertEventArgs e)
		{
			double test = double.Parse((string)e.Value);
			if ((string)this.tbSSN.Tag != "PARSE")
				e.Value = test.ToString("###-###-####");
			this.tbSSN.Tag = "FORMAT";
		}

		private void ParseSSN(Object sender, ConvertEventArgs e)
		{
			string str = (string)e.Value;
			e.Value = str.Trim("-".ToCharArray());

			this.tbSSN.Tag = "PARSE";
		}

		private void FormatChange(Object sender, EventArgs e)
		{
			BindingManagerBase bmb = (BindingManagerBase)sender;
			DataRowView drv = (DataRowView)bmb.Current;

			if (drv.Row.RowState == DataRowState.Added)
				this.tbTitle.Tag = "UNFORMATTED";
			else
				this.tbTitle.Tag = "FORMATTED";

		}

		private void btnPrevious_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[this.dsFrmFormatting, "Formatting"].Position -= 1;
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			this.BindingContext[this.dsFrmFormatting, "Formatting"].Position += 1;
		}

		private void tbTitle_Leave(Object sender, EventArgs e)
		{
			System.Globalization.TextInfo ti;

				ti = System.Globalization.CultureInfo.CurrentCulture.TextInfo;
				this.tbTitle.Text = ti.ToTitleCase(this.tbTitle.Text);
		}

		private void tbCharOnly_Keypress(Object sender, KeyPressEventArgs e)
		{
			if (Char.IsDigit(e.KeyChar))
				e.Handled = true;
		}

	}
}
