using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ColorCSharp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class KnownColors : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.Label Label13;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.TextBox LightLightSample;
		internal System.Windows.Forms.TextBox LightSample;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.TextBox DarkDarkSample;
		internal System.Windows.Forms.TextBox DarkSample;
		internal System.Windows.Forms.TextBox txtHTMLName;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.TextBox ColorSample;
		internal System.Windows.Forms.TextBox txtColorName;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.CheckBox cbSystem;
		internal System.Windows.Forms.CheckBox cbNamed;
		internal System.Windows.Forms.CheckBox cbKnown;
		internal System.Windows.Forms.TextBox txtBrightness;
		internal System.Windows.Forms.TextBox txtSaturation;
		internal System.Windows.Forms.TextBox txtHueValue;
		internal System.Windows.Forms.TextBox txtGreenValue;
		internal System.Windows.Forms.TextBox txtBlueValue;
		internal System.Windows.Forms.TextBox txtRedValue;
		internal System.Windows.Forms.TextBox txtAlphaValue;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.ListBox lstNamedColors;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public KnownColors()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			string[] theNamedColors;
			KnownColor myEnum = new KnownColor();
        
			theNamedColors = System.Enum.GetNames(myEnum.GetType());
			this.lstNamedColors.Items.AddRange(theNamedColors);


		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Label13 = new System.Windows.Forms.Label();
			this.Label14 = new System.Windows.Forms.Label();
			this.LightLightSample = new System.Windows.Forms.TextBox();
			this.LightSample = new System.Windows.Forms.TextBox();
			this.Label12 = new System.Windows.Forms.Label();
			this.Label11 = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.DarkDarkSample = new System.Windows.Forms.TextBox();
			this.DarkSample = new System.Windows.Forms.TextBox();
			this.txtHTMLName = new System.Windows.Forms.TextBox();
			this.Label10 = new System.Windows.Forms.Label();
			this.ColorSample = new System.Windows.Forms.TextBox();
			this.txtColorName = new System.Windows.Forms.TextBox();
			this.Label8 = new System.Windows.Forms.Label();
			this.cbSystem = new System.Windows.Forms.CheckBox();
			this.cbNamed = new System.Windows.Forms.CheckBox();
			this.cbKnown = new System.Windows.Forms.CheckBox();
			this.txtBrightness = new System.Windows.Forms.TextBox();
			this.txtSaturation = new System.Windows.Forms.TextBox();
			this.txtHueValue = new System.Windows.Forms.TextBox();
			this.txtGreenValue = new System.Windows.Forms.TextBox();
			this.txtBlueValue = new System.Windows.Forms.TextBox();
			this.txtRedValue = new System.Windows.Forms.TextBox();
			this.txtAlphaValue = new System.Windows.Forms.TextBox();
			this.Label7 = new System.Windows.Forms.Label();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label5 = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.Label3 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.lstNamedColors = new System.Windows.Forms.ListBox();
			this.SuspendLayout();
			// 
			// Label13
			// 
			this.Label13.AutoSize = true;
			this.Label13.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label13.Location = new System.Drawing.Point(440, 328);
			this.Label13.Name = "Label13";
			this.Label13.Size = new System.Drawing.Size(62, 14);
			this.Label13.TabIndex = 64;
			this.Label13.Text = "LightLight:";
			// 
			// Label14
			// 
			this.Label14.AutoSize = true;
			this.Label14.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label14.Location = new System.Drawing.Point(320, 328);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(35, 14);
			this.Label14.TabIndex = 63;
			this.Label14.Text = "Light:";
			// 
			// LightLightSample
			// 
			this.LightLightSample.Enabled = false;
			this.LightLightSample.Location = new System.Drawing.Point(440, 344);
			this.LightLightSample.Multiline = true;
			this.LightLightSample.Name = "LightLightSample";
			this.LightLightSample.Size = new System.Drawing.Size(104, 80);
			this.LightLightSample.TabIndex = 62;
			this.LightLightSample.Text = "";
			// 
			// LightSample
			// 
			this.LightSample.Enabled = false;
			this.LightSample.Location = new System.Drawing.Point(320, 344);
			this.LightSample.Multiline = true;
			this.LightSample.Name = "LightSample";
			this.LightSample.Size = new System.Drawing.Size(104, 80);
			this.LightSample.TabIndex = 61;
			this.LightSample.Text = "";
			// 
			// Label12
			// 
			this.Label12.AutoSize = true;
			this.Label12.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label12.Location = new System.Drawing.Point(440, 224);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(60, 14);
			this.Label12.TabIndex = 60;
			this.Label12.Text = "DarkDark:";
			// 
			// Label11
			// 
			this.Label11.AutoSize = true;
			this.Label11.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label11.Location = new System.Drawing.Point(320, 224);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(34, 14);
			this.Label11.TabIndex = 59;
			this.Label11.Text = "Dark:";
			// 
			// Label9
			// 
			this.Label9.AutoSize = true;
			this.Label9.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label9.Location = new System.Drawing.Point(208, 224);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(38, 14);
			this.Label9.TabIndex = 58;
			this.Label9.Text = "Color:";
			// 
			// DarkDarkSample
			// 
			this.DarkDarkSample.Enabled = false;
			this.DarkDarkSample.Location = new System.Drawing.Point(440, 240);
			this.DarkDarkSample.Multiline = true;
			this.DarkDarkSample.Name = "DarkDarkSample";
			this.DarkDarkSample.Size = new System.Drawing.Size(104, 80);
			this.DarkDarkSample.TabIndex = 57;
			this.DarkDarkSample.Text = "";
			// 
			// DarkSample
			// 
			this.DarkSample.Enabled = false;
			this.DarkSample.Location = new System.Drawing.Point(320, 240);
			this.DarkSample.Multiline = true;
			this.DarkSample.Name = "DarkSample";
			this.DarkSample.Size = new System.Drawing.Size(104, 80);
			this.DarkSample.TabIndex = 56;
			this.DarkSample.Text = "";
			// 
			// txtHTMLName
			// 
			this.txtHTMLName.Location = new System.Drawing.Point(208, 192);
			this.txtHTMLName.Name = "txtHTMLName";
			this.txtHTMLName.Size = new System.Drawing.Size(336, 20);
			this.txtHTMLName.TabIndex = 55;
			this.txtHTMLName.Text = "HTMLName";
			// 
			// Label10
			// 
			this.Label10.AutoSize = true;
			this.Label10.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label10.Location = new System.Drawing.Point(208, 176);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(78, 14);
			this.Label10.TabIndex = 54;
			this.Label10.Text = "HTML Name:";
			// 
			// ColorSample
			// 
			this.ColorSample.Enabled = false;
			this.ColorSample.Location = new System.Drawing.Point(208, 240);
			this.ColorSample.Multiline = true;
			this.ColorSample.Name = "ColorSample";
			this.ColorSample.Size = new System.Drawing.Size(104, 184);
			this.ColorSample.TabIndex = 53;
			this.ColorSample.Text = "";
			// 
			// txtColorName
			// 
			this.txtColorName.Location = new System.Drawing.Point(208, 152);
			this.txtColorName.Name = "txtColorName";
			this.txtColorName.Size = new System.Drawing.Size(336, 20);
			this.txtColorName.TabIndex = 52;
			this.txtColorName.Text = "ColorName";
			// 
			// Label8
			// 
			this.Label8.AutoSize = true;
			this.Label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label8.Location = new System.Drawing.Point(208, 136);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(41, 14);
			this.Label8.TabIndex = 51;
			this.Label8.Text = "Name:";
			// 
			// cbSystem
			// 
			this.cbSystem.Location = new System.Drawing.Point(440, 112);
			this.cbSystem.Name = "cbSystem";
			this.cbSystem.TabIndex = 50;
			this.cbSystem.Text = "System Color";
			// 
			// cbNamed
			// 
			this.cbNamed.Location = new System.Drawing.Point(328, 112);
			this.cbNamed.Name = "cbNamed";
			this.cbNamed.TabIndex = 49;
			this.cbNamed.Text = "Named Color";
			// 
			// cbKnown
			// 
			this.cbKnown.Location = new System.Drawing.Point(208, 112);
			this.cbKnown.Name = "cbKnown";
			this.cbKnown.TabIndex = 48;
			this.cbKnown.Text = "Known Color";
			// 
			// txtBrightness
			// 
			this.txtBrightness.Location = new System.Drawing.Point(448, 64);
			this.txtBrightness.Name = "txtBrightness";
			this.txtBrightness.TabIndex = 47;
			this.txtBrightness.Text = "BrightnessValue";
			// 
			// txtSaturation
			// 
			this.txtSaturation.Location = new System.Drawing.Point(448, 40);
			this.txtSaturation.Name = "txtSaturation";
			this.txtSaturation.TabIndex = 46;
			this.txtSaturation.Text = "SaturationValue";
			// 
			// txtHueValue
			// 
			this.txtHueValue.Location = new System.Drawing.Point(448, 16);
			this.txtHueValue.Name = "txtHueValue";
			this.txtHueValue.TabIndex = 45;
			this.txtHueValue.Text = "HueValue";
			// 
			// txtGreenValue
			// 
			this.txtGreenValue.Location = new System.Drawing.Point(256, 64);
			this.txtGreenValue.Name = "txtGreenValue";
			this.txtGreenValue.TabIndex = 44;
			this.txtGreenValue.Text = "GreenValue";
			// 
			// txtBlueValue
			// 
			this.txtBlueValue.Location = new System.Drawing.Point(256, 88);
			this.txtBlueValue.Name = "txtBlueValue";
			this.txtBlueValue.TabIndex = 43;
			this.txtBlueValue.Text = "BlueValue";
			// 
			// txtRedValue
			// 
			this.txtRedValue.Location = new System.Drawing.Point(256, 40);
			this.txtRedValue.Name = "txtRedValue";
			this.txtRedValue.TabIndex = 42;
			this.txtRedValue.Text = "RedValue";
			// 
			// txtAlphaValue
			// 
			this.txtAlphaValue.Location = new System.Drawing.Point(256, 16);
			this.txtAlphaValue.Name = "txtAlphaValue";
			this.txtAlphaValue.TabIndex = 41;
			this.txtAlphaValue.Text = "AlphaValue";
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label7.Location = new System.Drawing.Point(376, 64);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(66, 14);
			this.Label7.TabIndex = 40;
			this.Label7.Text = "Brightness:";
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label6.Location = new System.Drawing.Point(376, 40);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(64, 14);
			this.Label6.TabIndex = 39;
			this.Label6.Text = "Saturation:";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label5.Location = new System.Drawing.Point(376, 16);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(31, 14);
			this.Label5.TabIndex = 38;
			this.Label5.Text = "Hue:";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label4.Location = new System.Drawing.Point(208, 88);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(33, 14);
			this.Label4.TabIndex = 37;
			this.Label4.Text = "Blue:";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.Location = new System.Drawing.Point(208, 64);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(42, 14);
			this.Label3.TabIndex = 36;
			this.Label3.Text = "Green:";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.Location = new System.Drawing.Point(208, 40);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(31, 14);
			this.Label2.TabIndex = 35;
			this.Label2.Text = "Red:";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(208, 16);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(40, 14);
			this.Label1.TabIndex = 34;
			this.Label1.Text = "Alpha:";
			// 
			// lstNamedColors
			// 
			this.lstNamedColors.BackColor = System.Drawing.Color.White;
			this.lstNamedColors.Location = new System.Drawing.Point(16, 16);
			this.lstNamedColors.Name = "lstNamedColors";
			this.lstNamedColors.Size = new System.Drawing.Size(176, 407);
			this.lstNamedColors.TabIndex = 33;
			this.lstNamedColors.SelectedIndexChanged += new System.EventHandler(this.lstNamedColors_SelectedIndexChanged);
			// 
			// KnownColors
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(560, 437);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.Label13,
																		  this.Label14,
																		  this.LightLightSample,
																		  this.LightSample,
																		  this.Label12,
																		  this.Label11,
																		  this.Label9,
																		  this.DarkDarkSample,
																		  this.DarkSample,
																		  this.txtHTMLName,
																		  this.Label10,
																		  this.ColorSample,
																		  this.txtColorName,
																		  this.Label8,
																		  this.cbSystem,
																		  this.cbNamed,
																		  this.cbKnown,
																		  this.txtBrightness,
																		  this.txtSaturation,
																		  this.txtHueValue,
																		  this.txtGreenValue,
																		  this.txtBlueValue,
																		  this.txtRedValue,
																		  this.txtAlphaValue,
																		  this.Label7,
																		  this.Label6,
																		  this.Label5,
																		  this.Label4,
																		  this.Label3,
																		  this.Label2,
																		  this.Label1,
																		  this.lstNamedColors});
			this.Name = "KnownColors";
			this.Text = "Known Colors";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new KnownColors());
		}

		private void lstNamedColors_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			Color theColor = Color.FromName(this.lstNamedColors.SelectedItem.ToString());

			this.txtAlphaValue.Text = theColor.A.ToString();
			this.txtRedValue.Text = theColor.R.ToString();
			this.txtGreenValue.Text = theColor.G.ToString();
			this.txtBlueValue.Text = theColor.B.ToString();

			this.txtHueValue.Text = theColor.GetHue().ToString();
			this.txtSaturation.Text = theColor.GetSaturation().ToString();
			this.txtBrightness.Text = theColor.GetBrightness().ToString();

			this.cbKnown.Checked = theColor.IsKnownColor;
			this.cbNamed.Checked = theColor.IsNamedColor;
			this.cbSystem.Checked = theColor.IsSystemColor;

			this.txtColorName.Text = theColor.Name;
			this.txtHTMLName.Text = ColorTranslator.ToHtml(theColor);

			this.ColorSample.BackColor = theColor;
			this.DarkSample.BackColor = ControlPaint.Dark(theColor);
			this.DarkDarkSample.BackColor = ControlPaint.DarkDark(theColor);
			this.LightSample.BackColor = ControlPaint.Light(theColor);
			this.LightLightSample.BackColor = ControlPaint.LightLight(theColor);


		}
	}
}
