using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DatabaseIntegrityCSharp
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class LoadConstraints : System.Windows.Forms.Form
	{
		internal System.Data.OleDb.OleDbConnection cnLoadConstraints;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.DataSet dsMaster;
		internal System.Data.OleDb.OleDbDataAdapter daConstraints;
		internal System.Windows.Forms.TextBox tbThree;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.TextBox tbTwo;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox tbOne;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox tbID;
		internal System.Windows.Forms.Label Label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LoadConstraints()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.daConstraints.FillSchema(this.dsMaster, SchemaType.Source, "LoadConstraints");
			this.daConstraints.Fill(this.dsMaster.Tables["LoadConstraints"]);

	        DataTable dt = this.dsMaster.Tables["LoadConstraints"];
			this.tbID.DataBindings.Add("Text", dt, "RequiredID");
			this.tbOne.DataBindings.Add("Text", dt, "RequiredOne");
			this.tbTwo.DataBindings.Add("Text", dt, "OptionalTwo");
			this.tbThree.DataBindings.Add("Text", dt, "RequiredThree");

			tbID.Validating += new CancelEventHandler(CheckConstraints);
			tbOne.Validating += new CancelEventHandler(CheckConstraints);
			tbTwo.Validating += new CancelEventHandler(CheckConstraints);
			tbThree.Validating += new CancelEventHandler(CheckConstraints);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cnLoadConstraints = new System.Data.OleDb.OleDbConnection();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.dsMaster = new System.Data.DataSet();
			this.daConstraints = new System.Data.OleDb.OleDbDataAdapter();
			this.tbThree = new System.Windows.Forms.TextBox();
			this.Label4 = new System.Windows.Forms.Label();
			this.tbTwo = new System.Windows.Forms.TextBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.tbOne = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.tbID = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsMaster)).BeginInit();
			this.SuspendLayout();
			// 
			// cnLoadConstraints
			// 
			this.cnLoadConstraints.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Integrity.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT * FROM LoadConstraints";
			this.OleDbSelectCommand1.Connection = this.cnLoadConstraints;
			// 
			// dsMaster
			// 
			this.dsMaster.DataSetName = "NewDataSet";
			this.dsMaster.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// daConstraints
			// 
			this.daConstraints.SelectCommand = this.OleDbSelectCommand1;
			this.daConstraints.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									new System.Data.Common.DataTableMapping("Table", "LoadConstraints", new System.Data.Common.DataColumnMapping[] {
																																																					   new System.Data.Common.DataColumnMapping("OptionalOne", "OptionalOne"),
																																																					   new System.Data.Common.DataColumnMapping("RecquiredID", "RecquiredID"),
																																																					   new System.Data.Common.DataColumnMapping("RequiredOne", "RequiredOne"),
																																																					   new System.Data.Common.DataColumnMapping("RequiredTwo", "RequiredTwo")})});
			// 
			// tbThree
			// 
			this.tbThree.Location = new System.Drawing.Point(94, 80);
			this.tbThree.Name = "tbThree";
			this.tbThree.Size = new System.Drawing.Size(184, 20);
			this.tbThree.TabIndex = 15;
			this.tbThree.Text = "TextBox4";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Location = new System.Drawing.Point(14, 80);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(70, 16);
			this.Label4.TabIndex = 14;
			this.Label4.Text = "Three (reqd):";
			// 
			// tbTwo
			// 
			this.tbTwo.Location = new System.Drawing.Point(94, 56);
			this.tbTwo.Name = "tbTwo";
			this.tbTwo.Size = new System.Drawing.Size(184, 20);
			this.tbTwo.TabIndex = 13;
			this.tbTwo.Text = "TextBox3";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Location = new System.Drawing.Point(14, 56);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(29, 16);
			this.Label3.TabIndex = 12;
			this.Label3.Text = "Two:";
			// 
			// tbOne
			// 
			this.tbOne.Location = new System.Drawing.Point(94, 32);
			this.tbOne.Name = "tbOne";
			this.tbOne.Size = new System.Drawing.Size(184, 20);
			this.tbOne.TabIndex = 11;
			this.tbOne.Text = "TextBox2";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(14, 32);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(62, 16);
			this.Label2.TabIndex = 10;
			this.Label2.Text = "One (reqd):";
			// 
			// tbID
			// 
			this.tbID.Location = new System.Drawing.Point(94, 8);
			this.tbID.Name = "tbID";
			this.tbID.Size = new System.Drawing.Size(40, 20);
			this.tbID.TabIndex = 9;
			this.tbID.Text = "TextBox1";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(14, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(58, 16);
			this.Label1.TabIndex = 8;
			this.Label1.Text = "ID# (reqd):";
			// 
			// LoadConstraints
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 117);
			this.Controls.Add(this.tbThree);
			this.Controls.Add(this.Label4);
			this.Controls.Add(this.tbTwo);
			this.Controls.Add(this.Label3);
			this.Controls.Add(this.tbOne);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.tbID);
			this.Controls.Add(this.Label1);
			this.Name = "LoadConstraints";
			this.Text = "LoadConstraints";
			((System.ComponentModel.ISupportInitialize)(this.dsMaster)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new LoadConstraints());
		}

		private void CheckConstraints(Object sender, CancelEventArgs e)
		{
			TextBox theTB = sender as TextBox;
			String theColName = theTB.DataBindings["Text"].BindingMemberInfo.BindingField;
			DataColumn theCol = this.dsMaster.Tables["LoadConstraints"].Columns[theColName];

			if ((theCol.AllowDBNull == false) & ((theTB.Text).Length == 0))
			{
				MessageBox.Show("This value is required.");
				e.Cancel = true;
			}
		}

	}
}
