using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Drawing.Imaging;

namespace ImageExerciser
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class ImageExerciser : System.Windows.Forms.Form
	{
		Image myImage;
		internal System.Windows.Forms.Panel Panel1;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.PictureBox pbImage;
		internal System.Windows.Forms.Button btnFlip;
		internal System.Windows.Forms.Button btnRotate;
		internal System.Windows.Forms.Button btnGetThumbnail;
		internal System.Windows.Forms.TextBox tbResCount;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.TextBox tbPageCount;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.TextBox tbFrameCount;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.TextBox tbWidth;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.TextBox tbHeight;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.TextBox tbRawFormat;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox tbPixelFormat;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Button btnLoadImage;
		internal System.Windows.Forms.OpenFileDialog fdOpen;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ImageExerciser()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.Panel1 = new System.Windows.Forms.Panel();
			this.Label8 = new System.Windows.Forms.Label();
			this.pbImage = new System.Windows.Forms.PictureBox();
			this.btnFlip = new System.Windows.Forms.Button();
			this.btnRotate = new System.Windows.Forms.Button();
			this.btnGetThumbnail = new System.Windows.Forms.Button();
			this.tbResCount = new System.Windows.Forms.TextBox();
			this.Label7 = new System.Windows.Forms.Label();
			this.tbPageCount = new System.Windows.Forms.TextBox();
			this.Label5 = new System.Windows.Forms.Label();
			this.tbFrameCount = new System.Windows.Forms.TextBox();
			this.Label6 = new System.Windows.Forms.Label();
			this.tbWidth = new System.Windows.Forms.TextBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.tbHeight = new System.Windows.Forms.TextBox();
			this.Label4 = new System.Windows.Forms.Label();
			this.tbRawFormat = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.tbPixelFormat = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.btnLoadImage = new System.Windows.Forms.Button();
			this.fdOpen = new System.Windows.Forms.OpenFileDialog();
			this.SuspendLayout();
			// 
			// Panel1
			// 
			this.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.Panel1.Location = new System.Drawing.Point(8, 224);
			this.Panel1.Name = "Panel1";
			this.Panel1.Size = new System.Drawing.Size(368, 1);
			this.Panel1.TabIndex = 44;
			// 
			// Label8
			// 
			this.Label8.AutoSize = true;
			this.Label8.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label8.Location = new System.Drawing.Point(216, 232);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(86, 14);
			this.Label8.TabIndex = 43;
			this.Label8.Text = "Frame Counts:";
			// 
			// pbImage
			// 
			this.pbImage.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.pbImage.Location = new System.Drawing.Point(8, 8);
			this.pbImage.Name = "pbImage";
			this.pbImage.Size = new System.Drawing.Size(232, 208);
			this.pbImage.TabIndex = 42;
			this.pbImage.TabStop = false;
			// 
			// btnFlip
			// 
			this.btnFlip.Enabled = false;
			this.btnFlip.Location = new System.Drawing.Point(256, 104);
			this.btnFlip.Name = "btnFlip";
			this.btnFlip.Size = new System.Drawing.Size(120, 23);
			this.btnFlip.TabIndex = 3;
			this.btnFlip.Text = "Flip";
			this.btnFlip.Click += new System.EventHandler(this.btnFlip_Click);
			// 
			// btnRotate
			// 
			this.btnRotate.Enabled = false;
			this.btnRotate.Location = new System.Drawing.Point(256, 72);
			this.btnRotate.Name = "btnRotate";
			this.btnRotate.Size = new System.Drawing.Size(120, 23);
			this.btnRotate.TabIndex = 2;
			this.btnRotate.Text = "Rotate";
			this.btnRotate.Click += new System.EventHandler(this.btnRotate_Click);
			// 
			// btnGetThumbnail
			// 
			this.btnGetThumbnail.Enabled = false;
			this.btnGetThumbnail.Location = new System.Drawing.Point(256, 40);
			this.btnGetThumbnail.Name = "btnGetThumbnail";
			this.btnGetThumbnail.Size = new System.Drawing.Size(120, 23);
			this.btnGetThumbnail.TabIndex = 1;
			this.btnGetThumbnail.Text = "Get Thumbnail";
			this.btnGetThumbnail.Click += new System.EventHandler(this.btnGetThumbnail_Click);
			// 
			// tbResCount
			// 
			this.tbResCount.Location = new System.Drawing.Point(288, 328);
			this.tbResCount.Name = "tbResCount";
			this.tbResCount.Size = new System.Drawing.Size(96, 20);
			this.tbResCount.TabIndex = 10;
			this.tbResCount.Text = "ResCount";
			// 
			// Label7
			// 
			this.Label7.AutoSize = true;
			this.Label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label7.Location = new System.Drawing.Point(208, 331);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(66, 14);
			this.Label7.TabIndex = 37;
			this.Label7.Text = "Resolution:";
			// 
			// tbPageCount
			// 
			this.tbPageCount.Location = new System.Drawing.Point(288, 296);
			this.tbPageCount.Name = "tbPageCount";
			this.tbPageCount.Size = new System.Drawing.Size(96, 20);
			this.tbPageCount.TabIndex = 9;
			this.tbPageCount.Text = "PageCount";
			// 
			// Label5
			// 
			this.Label5.AutoSize = true;
			this.Label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label5.Location = new System.Drawing.Point(232, 299);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(43, 14);
			this.Label5.TabIndex = 35;
			this.Label5.Text = "Pages:";
			// 
			// tbFrameCount
			// 
			this.tbFrameCount.Location = new System.Drawing.Point(288, 264);
			this.tbFrameCount.Name = "tbFrameCount";
			this.tbFrameCount.Size = new System.Drawing.Size(96, 20);
			this.tbFrameCount.TabIndex = 8;
			this.tbFrameCount.Text = "FrameCount";
			// 
			// Label6
			// 
			this.Label6.AutoSize = true;
			this.Label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label6.Location = new System.Drawing.Point(240, 267);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(35, 14);
			this.Label6.TabIndex = 33;
			this.Label6.Text = "Time:";
			// 
			// tbWidth
			// 
			this.tbWidth.Location = new System.Drawing.Point(96, 264);
			this.tbWidth.Name = "tbWidth";
			this.tbWidth.Size = new System.Drawing.Size(96, 20);
			this.tbWidth.TabIndex = 5;
			this.tbWidth.Text = "Width";
			// 
			// Label3
			// 
			this.Label3.AutoSize = true;
			this.Label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label3.Location = new System.Drawing.Point(40, 267);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(40, 14);
			this.Label3.TabIndex = 31;
			this.Label3.Text = "Width:";
			// 
			// tbHeight
			// 
			this.tbHeight.Location = new System.Drawing.Point(96, 232);
			this.tbHeight.Name = "tbHeight";
			this.tbHeight.Size = new System.Drawing.Size(96, 20);
			this.tbHeight.TabIndex = 4;
			this.tbHeight.Text = "Height";
			// 
			// Label4
			// 
			this.Label4.AutoSize = true;
			this.Label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label4.Location = new System.Drawing.Point(40, 235);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(40, 14);
			this.Label4.TabIndex = 29;
			this.Label4.Text = "Height";
			// 
			// tbRawFormat
			// 
			this.tbRawFormat.Location = new System.Drawing.Point(96, 328);
			this.tbRawFormat.Name = "tbRawFormat";
			this.tbRawFormat.Size = new System.Drawing.Size(96, 20);
			this.tbRawFormat.TabIndex = 7;
			this.tbRawFormat.Text = "RawFormat";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label2.Location = new System.Drawing.Point(8, 331);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(72, 14);
			this.Label2.TabIndex = 27;
			this.Label2.Text = "RawFormat:";
			// 
			// tbPixelFormat
			// 
			this.tbPixelFormat.Location = new System.Drawing.Point(96, 296);
			this.tbPixelFormat.Name = "tbPixelFormat";
			this.tbPixelFormat.Size = new System.Drawing.Size(96, 20);
			this.tbPixelFormat.TabIndex = 6;
			this.tbPixelFormat.Text = "PixelFormat";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Label1.Location = new System.Drawing.Point(8, 299);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(74, 14);
			this.Label1.TabIndex = 25;
			this.Label1.Text = "PixelFormat:";
			// 
			// btnLoadImage
			// 
			this.btnLoadImage.Location = new System.Drawing.Point(256, 8);
			this.btnLoadImage.Name = "btnLoadImage";
			this.btnLoadImage.Size = new System.Drawing.Size(120, 24);
			this.btnLoadImage.TabIndex = 0;
			this.btnLoadImage.Text = "Load Image";
			this.btnLoadImage.Click += new System.EventHandler(this.btnLoadImage_Click);
			// 
			// fdOpen
			// 
			this.fdOpen.Filter = "All image files (*.bmp,*.gif, *.jpg, *.jpeg, *.png, *.ico, *.wmf, *.emf)|*.BMP;*." +
				"JPG;*.GIF;*.JPEG;*.ICO|Bitmap files (*.bmp, *.gif, *.jpg, *.jpeg, *.png, *.ico)|" +
				"*.BMP;*.GIF;*.JPG;*.JPEG;*.PNG;*.ICO|Metafiles (*.wmf, *emf)|*.WMF;*.EMF";
			this.fdOpen.Title = "Open Image";
			// 
			// ImageExerciser
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(392, 357);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.btnLoadImage,
																		  this.Panel1,
																		  this.Label8,
																		  this.pbImage,
																		  this.btnFlip,
																		  this.btnRotate,
																		  this.btnGetThumbnail,
																		  this.tbResCount,
																		  this.Label7,
																		  this.tbPageCount,
																		  this.Label5,
																		  this.tbFrameCount,
																		  this.Label6,
																		  this.tbWidth,
																		  this.Label3,
																		  this.tbHeight,
																		  this.Label4,
																		  this.tbRawFormat,
																		  this.Label2,
																		  this.tbPixelFormat,
																		  this.Label1});
			this.Name = "ImageExerciser";
			this.Text = "Image Exerciser";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new ImageExerciser());
		}

		private void btnLoadImage_Click(object sender, System.EventArgs e)
		{
			if (fdOpen.ShowDialog() == DialogResult.OK) 
			{
				myImage = Image.FromFile(fdOpen.FileName);

				//Display the image
				pbImage.Image = myImage;

				//Display image properties
				this.tbPixelFormat.Text = myImage.PixelFormat.ToString();
				this.tbHeight.Text = myImage.Height.ToString();
				this.tbWidth.Text = myImage.Width.ToString();
				try
				{
					this.tbFrameCount.Text = myImage.GetFrameCount(FrameDimension.Time).ToString();
				}
				catch
				{
					this.tbFrameCount.Text = "1";
				}
				try
				{
					this.tbPageCount.Text = myImage.GetFrameCount(FrameDimension.Page).ToString();
				}
				catch
				{
					this.tbPageCount.Text = "1";
				}
				try
				{
					this.tbResCount.Text = myImage.GetFrameCount(FrameDimension.Resolution).ToString();
				}
				catch
				{
					this.tbResCount.Text = "1";
				}


				//Display image type
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Bmp.Guid))
					tbRawFormat.Text = ImageFormat.Bmp.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Emf.Guid))
					tbRawFormat.Text = ImageFormat.Emf.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Exif.Guid)) 
					tbRawFormat.Text = ImageFormat.Exif.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Gif.Guid)) 
					tbRawFormat.Text = ImageFormat.Gif.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Icon.Guid)) 
					tbRawFormat.Text = ImageFormat.Icon.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Jpeg.Guid)) 
					tbRawFormat.Text = ImageFormat.Jpeg.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.MemoryBmp.Guid)) 
					tbRawFormat.Text = ImageFormat.MemoryBmp.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Png.Guid)) 
					tbRawFormat.Text = ImageFormat.Png.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Tiff.Guid)) 
					tbRawFormat.Text = ImageFormat.Tiff.ToString();
				if (myImage.RawFormat.Guid.Equals(ImageFormat.Wmf.Guid)) 
					tbRawFormat.Text = ImageFormat.Wmf.ToString();

				//Enable buttons
				this.btnFlip.Enabled = true;
				this.btnGetThumbnail.Enabled = true;
				this.btnRotate.Enabled = true;
			}
		}

		private void btnGetThumbnail_Click(object sender, System.EventArgs e)
		{
			Image myThumb;
			    
			myThumb = myImage.GetThumbnailImage(50, 50, null, new IntPtr());

			pbImage.Image = myThumb;
		}

		private void btnRotate_Click(object sender, System.EventArgs e)
		{
			Image newImage;

	        newImage = myImage;
			newImage.RotateFlip(RotateFlipType.Rotate180FlipNone);

			pbImage.Image = newImage;
		}

		private void btnFlip_Click(object sender, System.EventArgs e)
		{
			Image newImage;

			newImage = myImage;
			newImage.RotateFlip(RotateFlipType.RotateNoneFlipX);

			pbImage.Image = newImage;
		}

	}
}
