using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DataDisplayCSharp
{
	/// <summary>
	/// Summary description for Identity.
	/// </summary>
	public class Identity : System.Windows.Forms.Form
	{
		private BindingManagerBase bmb;

		internal System.Data.OleDb.OleDbConnection cnNavigation;
		private DataDisplayCSharp.dsIdentity dsFrmIdentity;
		internal System.Data.OleDb.OleDbDataAdapter daIdentity;
		internal System.Data.OleDb.OleDbCommand OleDbDeleteCommand1;
		internal System.Data.OleDb.OleDbCommand OleDbInsertCommand1;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.OleDb.OleDbCommand OleDbUpdateCommand1;
		internal System.Windows.Forms.TextBox tbValue;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.Panel pnlVideoButtons;
		internal System.Windows.Forms.Label lblNumRecords;
		internal System.Windows.Forms.TextBox tbCurrentRow;
		internal System.Windows.Forms.Button btnFirst;
		internal System.Windows.Forms.Button btnPrevious;
		internal System.Windows.Forms.Button btnNext;
		internal System.Windows.Forms.Button btnLast;
		internal System.Windows.Forms.Button btnNew;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label lblID;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Identity()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.daIdentity.Fill(this.dsFrmIdentity.IdentityTest);
			bmb = this.BindingContext[this.dsFrmIdentity, "IdentityTest"];

			this.btnFirst.Text = "|" + ((char)0x25C4).ToString();
			this.btnPrevious.Text = ((char)0x25C4).ToString();
			this.btnNext.Text = ((char)0x25BA).ToString();
			this.btnLast.Text = ((char)0x25BA).ToString() + "|";
			this.btnNew.Text = ((char)0x25BA).ToString() + "*";

			bmb.PositionChanged += new EventHandler(bmb_Changed);
			UpdateButtons();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		[STAThread]
		static void Main()
		{
			Application.Run(new Identity());
		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cnNavigation = new System.Data.OleDb.OleDbConnection();
			this.dsFrmIdentity = new DataDisplayCSharp.dsIdentity();
			this.daIdentity = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.OleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.OleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.tbValue = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			this.pnlVideoButtons = new System.Windows.Forms.Panel();
			this.lblNumRecords = new System.Windows.Forms.Label();
			this.tbCurrentRow = new System.Windows.Forms.TextBox();
			this.btnFirst = new System.Windows.Forms.Button();
			this.btnPrevious = new System.Windows.Forms.Button();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnLast = new System.Windows.Forms.Button();
			this.btnNew = new System.Windows.Forms.Button();
			this.Label2 = new System.Windows.Forms.Label();
			this.lblID = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmIdentity)).BeginInit();
			this.pnlVideoButtons.SuspendLayout();
			this.SuspendLayout();
			// 
			// cnNavigation
			// 
			this.cnNavigation.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\DataDisplay.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// dsFrmIdentity
			// 
			this.dsFrmIdentity.DataSetName = "dsIdentity";
			this.dsFrmIdentity.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// daIdentity
			// 
			this.daIdentity.DeleteCommand = this.OleDbDeleteCommand1;
			this.daIdentity.InsertCommand = this.OleDbInsertCommand1;
			this.daIdentity.SelectCommand = this.OleDbSelectCommand1;
			this.daIdentity.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								 new System.Data.Common.DataTableMapping("Table", "IdentityTest", new System.Data.Common.DataColumnMapping[] {
																																																				 new System.Data.Common.DataColumnMapping("RowID", "RowID"),
																																																				 new System.Data.Common.DataColumnMapping("Value", "Value")})});
			this.daIdentity.UpdateCommand = this.OleDbUpdateCommand1;
			// 
			// OleDbDeleteCommand1
			// 
			this.OleDbDeleteCommand1.CommandText = "DELETE FROM IdentityTest WHERE (RowID = ?) AND (Value = ? OR ? IS NULL AND Value " +
				"IS NULL)";
			this.OleDbDeleteCommand1.Connection = this.cnNavigation;
			this.OleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_RowID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "RowID", System.Data.DataRowVersion.Original, null));
			this.OleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Value", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Value", System.Data.DataRowVersion.Original, null));
			this.OleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Value1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Value", System.Data.DataRowVersion.Original, null));
			// 
			// OleDbInsertCommand1
			// 
			this.OleDbInsertCommand1.CommandText = "INSERT INTO IdentityTest(Value) VALUES (?)";
			this.OleDbInsertCommand1.Connection = this.cnNavigation;
			this.OleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Value", System.Data.OleDb.OleDbType.VarWChar, 50, "Value"));
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT * FROM IdentityTest";
			this.OleDbSelectCommand1.Connection = this.cnNavigation;
			// 
			// OleDbUpdateCommand1
			// 
			this.OleDbUpdateCommand1.CommandText = "UPDATE IdentityTest SET Value = ? WHERE (RowID = ?) AND (Value = ? OR ? IS NULL A" +
				"ND Value IS NULL)";
			this.OleDbUpdateCommand1.Connection = this.cnNavigation;
			this.OleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Value", System.Data.OleDb.OleDbType.VarWChar, 50, "Value"));
			this.OleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_RowID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "RowID", System.Data.DataRowVersion.Original, null));
			this.OleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Value", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Value", System.Data.DataRowVersion.Original, null));
			this.OleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_Value1", System.Data.OleDb.OleDbType.VarWChar, 50, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "Value", System.Data.DataRowVersion.Original, null));
			// 
			// tbValue
			// 
			this.tbValue.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmIdentity, "IdentityTest.Value"));
			this.tbValue.Location = new System.Drawing.Point(48, 32);
			this.tbValue.Name = "tbValue";
			this.tbValue.TabIndex = 8;
			this.tbValue.Text = "Value";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(25, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(19, 16);
			this.Label1.TabIndex = 7;
			this.Label1.Text = "ID:";
			// 
			// pnlVideoButtons
			// 
			this.pnlVideoButtons.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pnlVideoButtons.Controls.Add(this.lblNumRecords);
			this.pnlVideoButtons.Controls.Add(this.tbCurrentRow);
			this.pnlVideoButtons.Controls.Add(this.btnFirst);
			this.pnlVideoButtons.Controls.Add(this.btnPrevious);
			this.pnlVideoButtons.Controls.Add(this.btnNext);
			this.pnlVideoButtons.Controls.Add(this.btnLast);
			this.pnlVideoButtons.Controls.Add(this.btnNew);
			this.pnlVideoButtons.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.pnlVideoButtons.Location = new System.Drawing.Point(0, 78);
			this.pnlVideoButtons.Name = "pnlVideoButtons";
			this.pnlVideoButtons.Size = new System.Drawing.Size(336, 40);
			this.pnlVideoButtons.TabIndex = 4;
			// 
			// lblNumRecords
			// 
			this.lblNumRecords.AutoSize = true;
			this.lblNumRecords.Location = new System.Drawing.Point(296, 11);
			this.lblNumRecords.Name = "lblNumRecords";
			this.lblNumRecords.Size = new System.Drawing.Size(22, 16);
			this.lblNumRecords.TabIndex = 2;
			this.lblNumRecords.Text = "of y";
			// 
			// tbCurrentRow
			// 
			this.tbCurrentRow.Location = new System.Drawing.Point(88, 8);
			this.tbCurrentRow.Name = "tbCurrentRow";
			this.tbCurrentRow.Size = new System.Drawing.Size(80, 20);
			this.tbCurrentRow.TabIndex = 1;
			this.tbCurrentRow.TabStop = false;
			this.tbCurrentRow.Text = "x";
			this.tbCurrentRow.Validating += new System.ComponentModel.CancelEventHandler(this.tbCurrentRow_Validating);
			// 
			// btnFirst
			// 
			this.btnFirst.BackColor = System.Drawing.SystemColors.Control;
			this.btnFirst.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnFirst.Location = new System.Drawing.Point(8, 8);
			this.btnFirst.Name = "btnFirst";
			this.btnFirst.Size = new System.Drawing.Size(32, 23);
			this.btnFirst.TabIndex = 0;
			this.btnFirst.TabStop = false;
			this.btnFirst.Text = "|<";
			this.btnFirst.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.btnFirst.Click += new System.EventHandler(this.btnFirst_Click);
			// 
			// btnPrevious
			// 
			this.btnPrevious.BackColor = System.Drawing.SystemColors.Control;
			this.btnPrevious.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPrevious.Location = new System.Drawing.Point(48, 8);
			this.btnPrevious.Name = "btnPrevious";
			this.btnPrevious.Size = new System.Drawing.Size(32, 23);
			this.btnPrevious.TabIndex = 0;
			this.btnPrevious.TabStop = false;
			this.btnPrevious.Text = "<";
			this.btnPrevious.Click += new System.EventHandler(this.btnPrevious_Click);
			// 
			// btnNext
			// 
			this.btnNext.BackColor = System.Drawing.SystemColors.Control;
			this.btnNext.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnNext.Location = new System.Drawing.Point(176, 8);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(32, 23);
			this.btnNext.TabIndex = 0;
			this.btnNext.TabStop = false;
			this.btnNext.Text = ">";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// btnLast
			// 
			this.btnLast.BackColor = System.Drawing.SystemColors.Control;
			this.btnLast.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLast.Location = new System.Drawing.Point(216, 8);
			this.btnLast.Name = "btnLast";
			this.btnLast.Size = new System.Drawing.Size(32, 23);
			this.btnLast.TabIndex = 0;
			this.btnLast.TabStop = false;
			this.btnLast.Text = ">|";
			this.btnLast.Click += new System.EventHandler(this.btnLast_Click);
			// 
			// btnNew
			// 
			this.btnNew.BackColor = System.Drawing.SystemColors.Control;
			this.btnNew.Font = new System.Drawing.Font("Courier New", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnNew.Location = new System.Drawing.Point(256, 8);
			this.btnNew.Name = "btnNew";
			this.btnNew.Size = new System.Drawing.Size(32, 23);
			this.btnNew.TabIndex = 0;
			this.btnNew.TabStop = false;
			this.btnNew.Text = ">*";
			this.btnNew.Click += new System.EventHandler(this.btnNew_Click);
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(8, 34);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(36, 16);
			this.Label2.TabIndex = 5;
			this.Label2.Text = "Value:";
			// 
			// lblID
			// 
			this.lblID.AutoSize = true;
			this.lblID.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmIdentity, "IdentityTest.RowID"));
			this.lblID.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblID.Location = new System.Drawing.Point(48, 8);
			this.lblID.Name = "lblID";
			this.lblID.Size = new System.Drawing.Size(39, 16);
			this.lblID.TabIndex = 6;
			this.lblID.Text = "RowID";
			// 
			// Identity
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 118);
			this.Controls.Add(this.tbValue);
			this.Controls.Add(this.Label1);
			this.Controls.Add(this.pnlVideoButtons);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.lblID);
			this.Name = "Identity";
			this.Text = "Identity";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmIdentity)).EndInit();
			this.pnlVideoButtons.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		protected void bmb_Changed(Object sender, EventArgs e)
		{
			UpdateButtons();
		}
		protected void UpdateButtons()
		{
			int pos = this.bmb.Position;

			if (pos == 0)
			{
				this.btnPrevious.Enabled = false;
				this.btnNext.Enabled = true;
			}
			else 
			{
				if (pos == (bmb.Count - 1))
				{
					this.btnNext.Enabled = false;
					this.btnPrevious.Enabled = true;
				}
				else
				{
					this.btnNext.Enabled = true;
					this.btnPrevious.Enabled = true;
				}
			}

			DataRowState state = ((DataRowView)bmb.Current).Row.RowState;

			if ((state == DataRowState.Added) | (state == DataRowState.Detached))
				this.lblID.Visible = false;
			else
				this.lblID.Visible = true;


			this.tbCurrentRow.Text = (this.bmb.Position + 1).ToString();
			this.lblNumRecords.Text = "of " + this.bmb.Count.ToString();
		}

		private void btnFirst_Click(object sender, System.EventArgs e)
		{
			this.bmb.Position = 0;
		}

		private void btnPrevious_Click(object sender, System.EventArgs e)
		{
			this.bmb.Position -= 1;
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			this.bmb.Position += 1;
		}

		private void btnLast_Click(object sender, System.EventArgs e)
		{
			this.bmb.Position = this.bmb.Count - 1;
		}

		private void btnNew_Click(object sender, System.EventArgs e)
		{
			this.bmb.AddNew();
		}

		private void tbCurrentRow_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (this.tbCurrentRow.Text == "x")
			{
				this.tbCurrentRow.Text = (this.bmb.Position + 1).ToString();
				e.Cancel = true;
			}
			else
			{
				int row = int.Parse(this.tbCurrentRow.Text);
				if (row < 0) 
					this.tbCurrentRow.Text = "0";
				else
				{
					if (row > bmb.Count)
						this.tbCurrentRow.Text = bmb.Count.ToString();
				}
				this.bmb.Position = row - 1;
			}
		}
	}
}
