using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace ListControlsCSharp
{
	/// <summary>
	/// Summary description for ManyToOne.
	/// </summary>
	public class ManyToOne : System.Windows.Forms.Form
	{
		BindingManagerBase bmb;
		internal System.Data.OleDb.OleDbDataAdapter daRepresentatives;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand2;
		internal System.Data.OleDb.OleDbConnection cnChapter13;
		internal System.Data.OleDb.OleDbCommand OleDbSelectCommand1;
		internal System.Data.OleDb.OleDbDataAdapter daCustomerList;
		private ListControlsCSharp.dsChapter13 dsFrmChapter13;
		internal System.Windows.Forms.Button btnNext;
		internal System.Windows.Forms.Button btnPrevious;
		internal System.Windows.Forms.ListBox lbRepresentatives;
		internal System.Windows.Forms.TextBox tbName;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.TextBox tbID;
		internal System.Windows.Forms.Label Label1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public ManyToOne()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			try
			{
				this.daRepresentatives.Fill(this.dsFrmChapter13, "Representatives");
				this.daCustomerList.Fill(this.dsFrmChapter13, "CustomerList");
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.Message);
			}

			bmb = this.BindingContext[this.dsFrmChapter13, "CustomerList"];
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		[STAThread]
		static void Main() 
		{
			Application.Run(new ManyToOne());
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.daRepresentatives = new System.Data.OleDb.OleDbDataAdapter();
			this.OleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.cnChapter13 = new System.Data.OleDb.OleDbConnection();
			this.OleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.daCustomerList = new System.Data.OleDb.OleDbDataAdapter();
			this.dsFrmChapter13 = new ListControlsCSharp.dsChapter13();
			this.btnNext = new System.Windows.Forms.Button();
			this.btnPrevious = new System.Windows.Forms.Button();
			this.lbRepresentatives = new System.Windows.Forms.ListBox();
			this.tbName = new System.Windows.Forms.TextBox();
			this.Label2 = new System.Windows.Forms.Label();
			this.tbID = new System.Windows.Forms.TextBox();
			this.Label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).BeginInit();
			this.SuspendLayout();
			// 
			// daRepresentatives
			// 
			this.daRepresentatives.SelectCommand = this.OleDbSelectCommand2;
			this.daRepresentatives.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																										new System.Data.Common.DataTableMapping("Table", "Representatives", new System.Data.Common.DataColumnMapping[] {
																																																						   new System.Data.Common.DataColumnMapping("RepID", "RepID"),
																																																						   new System.Data.Common.DataColumnMapping("RepName", "RepName")})});
			// 
			// OleDbSelectCommand2
			// 
			this.OleDbSelectCommand2.CommandText = "SELECT RepID, RepName FROM Representatives";
			this.OleDbSelectCommand2.Connection = this.cnChapter13;
			// 
			// cnChapter13
			// 
			this.cnChapter13.ConnectionString = @"Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Registry Path=;Jet OLEDB:Database Locking Mode=1;Data Source=""..\..\Chapter13.mdb"";Jet OLEDB:Engine Type=5;Provider=""Microsoft.Jet.OLEDB.4.0"";Jet OLEDB:System database=;Jet OLEDB:SFP=False;persist security info=False;Extended Properties=;Mode=Share Deny None;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Create System Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;User ID=Admin;Jet OLEDB:Global Bulk Transactions=1";
			// 
			// OleDbSelectCommand1
			// 
			this.OleDbSelectCommand1.CommandText = "SELECT CustomerID, CustomerName, RepID FROM CustomerList";
			this.OleDbSelectCommand1.Connection = this.cnChapter13;
			// 
			// daCustomerList
			// 
			this.daCustomerList.SelectCommand = this.OleDbSelectCommand1;
			this.daCustomerList.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									 new System.Data.Common.DataTableMapping("Table", "CustomerList", new System.Data.Common.DataColumnMapping[] {
																																																					 new System.Data.Common.DataColumnMapping("CustomerID", "CustomerID"),
																																																					 new System.Data.Common.DataColumnMapping("CustomerName", "CustomerName"),
																																																					 new System.Data.Common.DataColumnMapping("RepID", "RepID")})});
			// 
			// dsFrmChapter13
			// 
			this.dsFrmChapter13.DataSetName = "dsChapter13";
			this.dsFrmChapter13.Locale = new System.Globalization.CultureInfo("en-US");
			// 
			// btnNext
			// 
			this.btnNext.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnNext.Location = new System.Drawing.Point(56, 272);
			this.btnNext.Name = "btnNext";
			this.btnNext.Size = new System.Drawing.Size(40, 23);
			this.btnNext.TabIndex = 14;
			this.btnNext.Text = ">";
			this.btnNext.Click += new System.EventHandler(this.btnNext_Click);
			// 
			// btnPrevious
			// 
			this.btnPrevious.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnPrevious.Location = new System.Drawing.Point(8, 272);
			this.btnPrevious.Name = "btnPrevious";
			this.btnPrevious.Size = new System.Drawing.Size(40, 23);
			this.btnPrevious.TabIndex = 13;
			this.btnPrevious.Text = "<";
			this.btnPrevious.Click += new System.EventHandler(this.btnPrevious_Click);
			// 
			// lbRepresentatives
			// 
			this.lbRepresentatives.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsFrmChapter13, "CustomerList.RepID"));
			this.lbRepresentatives.DataSource = this.dsFrmChapter13.Representatives;
			this.lbRepresentatives.DisplayMember = "RepName";
			this.lbRepresentatives.Location = new System.Drawing.Point(8, 64);
			this.lbRepresentatives.Name = "lbRepresentatives";
			this.lbRepresentatives.Size = new System.Drawing.Size(328, 199);
			this.lbRepresentatives.TabIndex = 12;
			this.lbRepresentatives.ValueMember = "RepID";
			// 
			// tbName
			// 
			this.tbName.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmChapter13, "CustomerList.CustomerName"));
			this.tbName.Location = new System.Drawing.Point(40, 32);
			this.tbName.Name = "tbName";
			this.tbName.Size = new System.Drawing.Size(288, 20);
			this.tbName.TabIndex = 11;
			this.tbName.Text = "Name";
			// 
			// Label2
			// 
			this.Label2.AutoSize = true;
			this.Label2.Location = new System.Drawing.Point(0, 32);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(38, 16);
			this.Label2.TabIndex = 10;
			this.Label2.Text = "Name:";
			// 
			// tbID
			// 
			this.tbID.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsFrmChapter13, "CustomerList.CustomerID"));
			this.tbID.Location = new System.Drawing.Point(40, 8);
			this.tbID.Name = "tbID";
			this.tbID.Size = new System.Drawing.Size(32, 20);
			this.tbID.TabIndex = 9;
			this.tbID.Text = "ID";
			// 
			// Label1
			// 
			this.Label1.AutoSize = true;
			this.Label1.Location = new System.Drawing.Point(8, 8);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(19, 16);
			this.Label1.TabIndex = 8;
			this.Label1.Text = "ID:";
			// 
			// ManyToOne
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(358, 309);
			this.Controls.Add(this.btnNext);
			this.Controls.Add(this.btnPrevious);
			this.Controls.Add(this.lbRepresentatives);
			this.Controls.Add(this.tbName);
			this.Controls.Add(this.Label2);
			this.Controls.Add(this.tbID);
			this.Controls.Add(this.Label1);
			this.Name = "ManyToOne";
			this.Text = "ManyToOne";
			((System.ComponentModel.ISupportInitialize)(this.dsFrmChapter13)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void btnPrevious_Click(object sender, System.EventArgs e)
		{
			if (bmb.Position > 0) bmb.Position -= 1;
		}

		private void btnNext_Click(object sender, System.EventArgs e)
		{
			if (bmb.Position < bmb.Count) bmb.Position += 1;
		}
	}
}
